<?php

// =========================================================
//

// This Software is copyright (c) 2007 by telepark, 
// Inh. Patrick Thomas, www.telepark.de. 
// All rights reserved. 

// You may not modify, alter, reverse engineer or emulate 
// the functionality, or create derivative works of the 
// Software in parts or it's entirety without the prior
// written consent of telepark.
// =========================================================

class Wiki extends WikiPro{		
//class Wiki {
	
	// folders
	var $userfiles;
	var $userfiles_changes;
	var $userfiles_pages;
	var $userfiles_menu;
	var $userfiles_uploads;
	var $system_message;	
	
	// files
	var $changelog_filename;
	var $menu_filename;
	
	// other variables
	var $js = "";
	var $display_textlinks;
	var $tree;
	var $get;
	var $usersdata;
	var $maxlevels;
	var $debug;
	var $pingtime; //seconds
	var $defaultXMLwritten;
		
	/**
	 * Constructor (PHP5)
	 *
	 */
	function __construct() {	
		// folders
		$host=$_SERVER['HTTP_HOST'];
		if ($host!="localhost") {
			$key=explode("|",base64_decode(KEYCODE));
			if (($key[0]!=$host) AND ($key[0]!="any")) die(str_Keycode);
		}
		$this->userfiles = "UserFiles/";
		$this->userfiles_changes = "UserFiles/Changes/";
		$this->userfiles_pages = "UserFiles/Pages/";
		$this->userfiles_menu = "UserFiles/Menu/";
		$this->userfiles_uploads = "UserFiles/upload/";
		$this->modules_dir = "modules/";
		// files
		$this->changelog_filename = "changestamp.log";
		$this->menu_filename = "menu.xml";
		// text links
		$this->display_textlinks = DISPLAYTEXTLINKS;

		$db=new Database();
		// get all groups
		if (!isset($_SESSION[WIKI_PREFIX."allgroups"])) {
			$db->query("groups");
			$allgroups="";
			while ($row=$db->fetch_row()) {
				if ($allgroups!="") $allgroups.=",";
				$allgroups.=$row['groupname'];
			}
			$_SESSION[WIKI_PREFIX."allgroups"]=$allgroups;
		}

		// defines
		if( !defined("str_COMMENT") )
		define("str_COMMENT", "Comment");
		
		if( !defined("str_COMMENTLIST") )
		define("str_COMMENTLIST", "Comments");
		
		if( !defined("str_ATTACHMENT") )
		define("str_ATTACHMENT", "File attachment");
		
		if( !defined("str_UPLOADFILE") )
		define("str_UPLOADFILE", "Upload file");
		
		if( !defined("str_FILETITLE") )
		define("str_FILETITLE", "Title");
		
		if( !defined("str_FILENAME") )
		define("str_FILENAME", "File");
		

		$this->usersdata=array("sa"=>"0","levels"=>"0");
		
		$this->maxlevels=array();
		
		$this->debug=false;

		$this->checkLogin();		 

		$this->tree=array();

		$this->defaultXMLwritten=false;

		$oldTree=$this->unserializeTree(false,true);
		
		if ($oldTree!==false) $this->writeDefaultMenuXML();

		if (!isset($_SESSION[WIKI_PREFIX."treemd5"])) $_SESSION[WIKI_PREFIX."treemd5"]="";
		 
		 if (!isset($_SESSION[WIKI_PREFIX."treeUser"])) $_SESSION[WIKI_PREFIX."treeUser"]=$this->loggedUserId();
		 
		if (!isset($_SESSION[WIKI_PREFIX."wikitree"]) || $_SESSION[WIKI_PREFIX."treemd5"]!=$db->sum("tree") || $_SESSION[WIKI_PREFIX."treeUser"]!=$this->loggedUserId()) {
			$this->tree=$this->unserializeTree(true);
			$_SESSION[WIKI_PREFIX."wikitree"]=$this->tree;
			$_SESSION[WIKI_PREFIX."treemd5"]=$db->sum("tree");
			$_SESSION[WIKI_PREFIX."treeUser"]=$this->loggedUserId();
		} else {
			$this->tree=$_SESSION[WIKI_PREFIX."wikitree"];
		}		

		$this->pingtime=SERVER_PING_TIME+0;
		// WikiPro constructor
		parent::__construct();		
	}
	
	/**
	 * Constructor (PHP4)
	 *
	 * @return Wiki
	 */
	function Wiki() {
		if ((int) phpversion()<5) $this->__construct();
	}
	
	/**
	 * Html header
	 *
	 */
	function htmlheader() {
		$this->writeDefaultMenuXML();
		$this->writeHtpasswd();
		$this->writeHtaccess();
		$version=getVersionNumber(PRE."changelog.txt");
		$metaKey="";
		$metaDesc="";
		if (CALLED_PAGEID!="") {
			$metaKey=$this->keywords(CALLED_PAGEID);
			$metaDesc=$this->description(CALLED_PAGEID);
		}
		echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
		echo "<html>\n";
  		echo "<head>\n";
  		echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n";
  		echo "<meta http-equiv=\"pragma\" content=\"no-cache\">\n";
  		echo "<title>" . $this->pageTitle() ."</title>\n";
		if ($this->js!="menulist") {
			echo "<meta name=\"keywords\" content=\"".$metaKey."\">\n";
			echo "<meta name=\"description\" content=\"".$metaDesc."\">\n";
		}
 		if (file_exists(PRE."favicon.ico")) {
	 		echo "<link rel=\"icon\" href=\"favicon.ico\" type=\"image/x-icon\"> \n";
	 		echo "<link rel=\"shortcut icon\" href=\"favicon.ico\" type=\"image/x-icon\"> \n";
 		}
 		echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/dhtmlXTree.css\">\n";
		if ($this->js!="menulist") {
			echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/dhtmlxmenu_standard.css\">\n";
		}
		echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/wiki.css\">\n";
  		include_once(PRE . "js/defined.js.php");
  		if ($this->js=="menulist") {
  			echo "<script type=\"text/javascript\" language=\"javascript\">var userid=\"".(isset($_GET['useridfortree'])?$_GET['useridfortree']:"")."\";</script>";
  		}
  		echo "</head>\n";
		echo "<body onLoad=\"working(true); checkLogin(); windowResize();\"" . ($this->js!="menulist"?" onBeforeUnload=\"try { killSession(); checkLockFiles(); } catch(e) {}; try { tree.destructor(); } catch(e) {} \"":"") . ">\n";		
	}

	function htmlheaderrestore($restore="") {
		$wikijs="wiki.js";
		if ($restore=="restore") $wikijs="wikirestore.js";
		echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
		echo "<html>\n";
  		echo "<head>\n";
  		echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n";
  		echo "<meta http-equiv=\"pragma\" content=\"no-cache\">\n";
  		echo "<title>" . SITETITLE . " | ".PRODUCT." " . getVersionNumber("changelog.txt") . " Professional</title>\n";
  		echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/dhtmlXTree.css\">\n";
		if ($this->js!="menulist") {
			echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/dhtmlXMenu.css\">\n";
  			echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/Context.css\">\n";
		}
		echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/wiki.css\">\n";
//		echo '<!--[if lt IE 7.]>'."<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/png.css\">\n".'<![endif]-->';
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlXCommon.js\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlXTreeRestore.js\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlXTree_xw.js\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlXTree_ed.js\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlXTree_sb.js\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlXProtobar.js\"></script>\n";
		if ($this->js!="menulist") {
			echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlXMenuBar.js\"></script>\n";
			echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlXMenuBar_cp.js\"></script>\n";
			echo "<script type=\"text/javascript\" src=\"" . PRE . "js/ajax.js\"></script>\n";
			echo "<script type=\"text/javascript\" src=\"" . PRE . "FCKeditor/fckeditor.js\"></script>\n";
		}
  		include_once(PRE . "js/defined.js.php");
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/settings.js\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/" . ($this->js=="menulist"?"wiki_menulist.js":"$wikijs") . "\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/colorpicker.js\" ></script>\n";
  		echo "</head>\n";
  		//echo "<body onLoad=\"loadTree(); windowResize();\">\n";
		echo "<body onLoad=\"loadTree(); windowResize();\"" . ($this->js!="menulist"?" onUnload=\"checkLockFiles();\"":"") . ">\n";		
	}
	
	/**
	 * Html header for ptinting
 	 *
	 */
	function htmlheaderprint() {
		echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
		echo "<html>\n";
  		echo "<head>\n";
  		echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n";
  		echo "<meta http-equiv=\"pragma\" content=\"no-cache\">\n";
  		echo "<title>" . $this->pageTitle() . "</title>\n";
  		echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/dhtmlXTree.css\">\n";
		if ($this->js!="menulist") {
			echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/dhtmlXMenu.css\">\n";
  			echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/Context.css\">\n";
		}
		echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/wiki.css\">\n";
		echo '<!--[if lt IE 7.]>'."<link rel=\"stylesheet\" type=\"text/css\" href=\"" . PRE . "css/png.css\">\n".'<![endif]-->';

		echo "<body onload='window.print()'>\n";		
	}
	
	/**
	 * Top banner
	 *
	 */
	function topbanner() {
		if (TOPBANNER=="YES") {
			echo "<div id=\"topbanner\" style=\"background-image: url(imgs/" . IMG_TOPBANNER . "); \">";
		} else {
			echo "<div id=\"topbanner\" >";
		}
		// logo
		echo $this->logo();			
		// search
	    echo $this->searchBox();		
	    // sign box
	    echo $this->signBox();		
	    // text links
	    echo $this->textlinks();
		echo "</div>\n";
	}
	
	/**
	 * Small top banner
	 *
	 */
	function small_topbanner() {
		$img = PRE."imgs/".LOGO_IMG;
		$size = $this->getImageInfo($img);
		echo "<div id=\"logo\" style=\"top:0; left:0; margin:5px;\">";
		echo "<a href=\"index.php\" onClick=\"self.close();\">";
		echo "<img src=\"" . $img . "\" alt=\"" . SITETITLE . "\" title=\"" . SITETITLE . "\" width=\"" . $size['width'] . "\" height=\"" . $size['height'] . "\" border=\"0\" />";
		echo "</a>";
		echo "</div>";
		echo "<div class=\"intBrowserText\">" . str_INTERNALBOWSER . "</div>";
	}
	
	/**
	 * Display logo
	 *
	 * @return string
	 */
	function logo() {
		$img = PRE."imgs/".LOGO_IMG;
		$size = $this->getImageInfo($img);
		$s = "<div id=\"logo\">";
		$s .= "<a href=\"" . ROOT_URL . "/\">";
		$s .= "<img src=\"" . $img . "\" alt=\"" . SITETITLE . "\" title=\"" . SITETITLE . "\" width=\"" . $size['width'] . "\" height=\"" . $size['height'] . "\" border=\"0\" />";
		$s .= "</a>";
		$s .= "</div>";
		return $s;
	}
	
	/**
	 * Textlinks
	 *
	 */
	function textlinks() {
		$s = "<div id=\"textlinks\" style=\"width:" . TREE_WIDTH . ";\">";
		$s .= "<span id=\"addLink\" style=\"display: none;\"><a href=\"#\" onClick=\"onButtonClick('add',tree.getSelectedItemId()); return false;\">" . str_ADD . "</a> &nbsp; </span>";
		$s .= "<span id=\"editLink\" style=\"display: none;\"><a href=\"#\" onClick=\"onButtonClick('edit',tree.getSelectedItemId()); return false;\">" . str_EDIT . "</a> &nbsp; </span>";
		$s .= "<span id=\"deleteLink\" style=\"display: none;\"><a href=\"#\" onClick=\"onButtonClick('delete',tree.getSelectedItemId()); return false;\">" . str_DELETE . "</a> &nbsp;</span> ";
		$s .= "<span id=\"sortLink\" style=\"display: none;\"><a href=\"#\" onClick=\"onButtonClick('sort',tree.getSelectedItemId()); return false;\">" . str_SORT . "</a> &nbsp; </span>";
		$s .= "<span id='printPageSpan' style=\"display: none;\"><a href=\"#\" onClick=\"onButtonClick('print',tree.getSelectedItemId()); return false;\">" . str_PRINT . "</a> &nbsp; </span>";
		$s .= "<span id=\"changePassLink\" style=\"display: none;\"><a href=\"#\" onClick=\"onButtonClick('changepass',tree.getSelectedItemId()); return false;\">" . str_CHANGE_PASSWORD . "</a> &nbsp; </span>";
		$s .= "<span id=\"settingsLink\" style=\"display: none;\"><a href=\"#\" onClick=\"onButtonClick('settings',tree.getSelectedItemId()); return false;\">" . str_SETTINGS . "</a> &nbsp; </span>";
		$s .= "<span id=\"privilegesLink\" style=\"display: none;\"><a href=\"#\" onClick=\"onButtonClick('privileges',tree.getSelectedItemId()); return false;\">" . str_PRIVILEGES . "</a></span>";
		$s .= "</div>\n";
		return $s;
	}
	
	/**
	 * System messages
	 *
	 */
	function messagebox() {
		global $errormsg;
		
		if ($errormsg != "") $this->system_message = $errormsg;
		
		if ($this->system_message != "") {
			$display = "block";
		}
		else {
			$display = "none";
		}
		echo "<div id=\"messageBox\" style=\"left: 30px; display:" . $display . ";\">";
		echo "<h1>" . str_MESSAGE . "</h1>";
		echo "<div id=\"innerMessage\">" . $this->system_message . "</div>";
		echo "<br /><br /><input type=\"button\" value=\"" . str_CLOSE . "\" onClick=\"closeMessageBox();\" class=\"wikiButton\" />";
		echo "</div>\n";
	}
	
	/**
	 * System actions
	 *
	 */
	function actionsbox() {
		echo "<div id=\"actionsBox\">";
		echo "<table style=\"width: 400px\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\"><tr>";
		echo "<td style=\"padding: 5px; cursor: pointer; text-align: center; background-color: Highlight; color: HighlightText; font-weight: bold; font-size: 14px;\"><div id=\"actionsBoxHead\" style=\"width: 100%; text-align: left; cursor: move\" onmousedown=\"drag('actionsBox')\" onmouseup=\"drop()\">&nbsp;</div></td>";
		echo "<td style=\"text-align: right; padding: 5px; background-color: Highlight; color: HighlightText; font-weight: bold; font-size: 14px;\"><a href=\"\" onClick=\"closeActionsBox(); return false;\"><img border=\"0\" src=\"imgs/close.gif\" width=\"21\" height=\"21\" alt=\"" . str_CLOSE . "\" title=\"" . str_CLOSE . "\" /></a></td>";
		echo "</tr><td colspan=\"2\">";
		echo "<div id=\"actionsBoxInner\"></div></td></tr></table>";
		echo "</div>\n";
	}
	
	/**
	 * Tree box
	 *
	 */
	function treebox() {
		echo "<div id=\"contextMenu\" style=\"display: none;\"></div>\n";
		echo "<div id=\"treeboxLoading\" class=\"standartTreeRow\" style=\"display: none; position: absolute; z-index: 90000; padding: 0; font-weight: bold; background-color: transparent; width:" . TREE_WIDTH . ";\">Loading...</div>\n";
		echo "<div id=\"treebox\" style=\"width:" . TREE_WIDTH . ";\"></div>\n";
		//echo "<script>document.getElementById('treebox').style.height=(document.body.clientHeight-125);</script>\n";
	}
	
	/**
	 * Login button
	 *
	 */
	function loginButton() {
		echo "<div id=\"loginButton\">";
			if (isset($_SESSION[WIKI_PREFIX.'wloginsess']) && isset($_SESSION[WIKI_PREFIX.'wloginpass'])) {
				echo "<a href=\"#\" id=\"loginlink\" onClick=\"logout();\">" . $_SESSION[WIKI_PREFIX.'wusername'] . " - " . str_LOGOUT . "</a>";
			} else {
				echo "<a href=\"#\" id=\"loginlink\" onClick=\"checkLogin();\">" . str_LOGIN . "</a>";
			}
		echo "</div>\n";
	}
	
	/**
	 * Login box
	 *
	 */
	function loginBox() {
		echo "<div id=\"loginBox\" style=\"display:none; left: 10px;\"><div id=\"innerLoginBox\">";
		echo "<form name=\"login\" method=\"get\" action=\"\" onSubmit=\"submitLogin(); return false;\" style=\"margin:0;padding:0;\">\n";
		echo '<table cellpadding="0" cellspacing="5" border="0">';
		echo "<tr><td>" . str_ASKNAME . "</td><td><input type=\"text\" name=\"loginBoxName\" id=\"loginBoxName\" value=\"\" /></td></tr>";
		echo "<tr><td>" . str_ASKPASSWORD . "</td><td><input type=\"password\" name=\"loginBoxPass\" id=\"loginBoxPass\" value=\"\" /></td></tr>";
		echo "<tr><td>" . str_REMEMBERME . "</td><td><input type=\"checkbox\" name=\"loginRemember\" id=\"loginRemember\" value=\"1\" checked=\"checked\" /></td></tr>";
		echo "<tr><td style=\"text-align: center\" colspan=\"2\"><input type=\"submit\" name=\"loginBoxSubmit\" id=\"loginBoxSubmit\" value=\"" . str_LOGIN . "\" class=\"wikiButton\" onClick=\"submitLogin();\" /></td></tr>";
		echo "</table>\n";
		echo "</form></div>\n";
		echo "<div id=\"closeButton\"><a href=\"\" onClick=\"hideLoginBox(); return false;\"><img border=\"0\" src=\"imgs/close.gif\" width=\"21\" height=\"21\" alt=\"" . str_CLOSE . "\" title=\"" . str_CLOSE . "\" /></a></div>";
		echo "</div>\n";
	}
	
	/**
	 * Loading status
	 *
	 */
	function status() {
		echo "<div id=\"loading\" style=\"display:block;\"><img src=\"".PRE."imgs/anim-loading.gif\" alt=\"Loading\" />";
		echo "<div style=\"position:absolute; left:38px; top:5px; z-index:10;\"><img src=\"".PRE."imgs/anim-progress.gif\" /></div>\n";
		echo "</div>\n";
	}
	
	/**
	 * Display version number
	 *
	 */
	function versionNumber() {
		echo "<div id=\"version\">";
		echo getVersionNumber("changelog.txt") . " Professional";
		echo "</div>\n";
	}
	
	/**
	 * Content area
	 *
	 */
	function main_start() {
		echo "<div id=\"main\" style=\"left:" . (intval(TREE_WIDTH)+10) . "px; width: " . CONTENT_WIDTH . ";\">";
	}

	function main_end() {
		echo "</div>\n";		
	}
	
	function content() {
		$pageid="wiki";
		if (defined("CALLED_PAGEID") && CALLED_PAGEID!="") $pageid=CALLED_PAGEID;
		$page=$this->wikiPage($pageid);
		preg_match_all("/<script.*>.*<\\/script>/msU",$page,$scripts,PREG_SET_ORDER);
		foreach ($scripts as $script) {
			$page=str_replace($script[0],"",$page);
		}
		echo "<noscript>".str_NOSCRIPT."</noscript>\n";
		echo "<div id=\"stylesTestDiv\" style=\"display: none\"></div>\n";
		echo "<div id=\"content\" style=\"width: " . CONTENT_WIDTH . ";\">".$page."</div>";
	}
	
	/**
	 * Action frame
	 *
	 */
	function actionFrame() {
		echo "<div style=\"width:0; height:0; border:0;\"><iframe id=\"actionFrame\" src=\"ajax/blank.php\" name=\"actionFrame\" width=\"0\" height=\"0\" frameborder=\"0\"></iframe></div>\n";
		//echo "<iframe src=\"ajax/blank.php\" name=\"actionFrame\" width=\"300\" height=\"300\" frameborder=\"1\"></iframe>\n";
	}
	
	/**
	 * Html footer
	 *
	 */
	function htmlfooter() {
		$version=getVersionNumber(PRE."changelog.txt");
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/ajax.js?version=$version\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlxcommon.js\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlxtree.js\"></script>\n";		
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlxtree_xw.js\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlxtree_sb.js\"></script>\n";
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlxtree_lf.js\"></script>\n";
		if ($this->js!="menulist") {
			echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlxdataprocessor.js\"></script>\n";		
			echo "<script type=\"text/javascript\" src=\"" . PRE . "js/dhtmlxmenu.js\"></script>\n";
			echo "<script type=\"text/javascript\" src=\"" . PRE . "FCKeditor/fckeditor.js\"></script>\n";
			echo "<script type=\"text/javascript\" src=\"" . PRE . "js/permissions.js?version=$version\"></script>\n";
			echo "<script type=\"text/javascript\" src=\"" . PRE . "js/settings.js?version=$version\"></script>\n";
			echo "<script type=\"text/javascript\" src=\"" . PRE . "js/drag.js?version=$version\"></script>\n";
			echo "<script type=\"text/javascript\" src=\"" . PRE . "js/colorpicker.js?version=$version\" ></script>\n";
		}
		echo "<script type=\"text/javascript\" src=\"" . PRE . "js/" . ($this->js=="menulist"?"wiki_menulist.js":"wiki.js") . "?version=".$version."\"></script>\n";
		$db=new Database();
		$db->create("gacode","id,gacode");
		$db->query("gacode");
		if ($db->num_rows()!=0) {
			$tmp=$db->fetch_row();
			$gacode=$tmp['gacode'];
			echo $gacode;
		}
		echo "</body>\n";
		echo "</html>\n";
	}
	
	function htmlfooterNS() {
		echo "</body>\n";
		echo "</html>\n";
	}
	
	/**
	 * Add / edit form
	 *
	 * @param string $pageID
	 * @return string
	 */
	function wikiForm($pageID='-1',$perms) {
		if ($this->fileLocked($pageID)) return err_FILELOCKED;			
		
		$newpage=true;		
		if ($pageID!='-1') {
			$newpage=false;
			$data = $this->loadPage($pageID);
			$history = $this->loadHistory($pageID);
			$this->lockFile($pageID);					
		}

		// is module page?
		$module="";
		$mod="";
		if (isset($data['wikiModule'])) {
			$mod=trim($data['wikiModule']);
			if ($mod!="") $module=$this->loadModuleAdmin($mod,$pageID);
		} 
		
		// superadmin page and not logged in as superadmin					
		if (isset($data['wikiSuperadminPage']) && $data['wikiSuperadminPage'] == 1 && $_SESSION[WIKI_PREFIX.'wsuperadmin'] != 1) {
			return str_PLEASELOGIN;
		}
		
		$s = "<h1>" . str_EDITPAGE . "</h1>\n";
		//$s .= "<form name=\"wikiForm\" action=\"ajax/saveForm.php\" method=\"post\" target=\"actionFrame\" onSubmit=\"return checkEditorChanges(document.getElementById('wikiMenuLabelOrig').value,'';\">\n";
		$s .= "<form name=\"wikiForm\" action=\"ajax/saveForm.php\" method=\"post\" target=\"actionFrame\" onSubmit=\"return false\" enctype=\"multipart/form-data\">\n";		
		$s .= "<table class=\"wikiForm\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\">\n";
		// Menu label
		$s .= "<tr>\n";
		$s .= "<th style=\"width:100px;\">" . str_MENULABEL . ": </th>\n";
		$s .= "<td style=\"width:90%\">";
		$s .= "<input style=\"width:100%;\" type=\"text\" id=\"wikiMenuLabel\" name=\"wikiMenuLabel\" value=\"" . (isset($data['wikiMenuLabel'])?htmlspecialchars($data['wikiMenuLabel'],ENT_QUOTES):str_NEWPAGE) . "\" onchange=\"titleChanged(this)\"\"/>\n";
		$s .= "<input type=\"hidden\" id=\"wikiMenuLabelOrig\" value=\"" . (isset($data['wikiMenuLabel'])?htmlspecialchars($data['wikiMenuLabel'],ENT_QUOTES):str_NEWPAGE) . "\" />\n";
		$s .= "</td>\n";
		$s .= "</tr>\n";

		//modules
		if ($pageID!="wiki") {
			$allmodules=$this->getModules();
			if (count($allmodules)>0) {
				$s .= "<tr>\n";
				$s .= "<th style=\"width:100px;\">" . str_MODULES . ": </th>\n";
				$s .= "<td style=\"width:90%\">";
				$s .= "<select name=\"wikiModule\" onchange=\"moduleSubmitted=false; if (this.value!='') moduleSubmitted=true; submitWikiForm()\">\n";
				$s .= "<option value=\"\">---</option>\n";
				foreach ($allmodules as $mods) {
					$s .= "<option value=\"$mods\"";
					if ($mod==$mods) $s.=' selected="selected"';
					$s.=">".$this->moduleName($mods)."</option>\n";
				}
				$s .= "</select>\n";
				$s .= "</td>\n";
				$s .= "</tr>\n";
			}
		}
		
		$hide="";		
		if ($module!="") {
			$s.="<tr>\n";
			$s.="<td colspan=\"2\" style=\"border: black solid 1px;\">";
			$s.="<input type=\"hidden\" id=\"continueEdit\" name=\"continueEdit\" value=\"$mod\" style=\"display: none\" />";
			$s.="<div style=\"display: none\">###THIS IS WIKI MODULE PAGE###</div>";
			$s.="$module</td>\n";
			$s.="</tr>\n";
			$hide='style="display: none"';
		}
		// Content
		$s .= "<tr $hide>\n";
		$s .= "<td colspan=\"2\">";
		$s .= "<textarea style=\"width:" . (950-intval(TREE_WIDTH)) . "px;\" id=\"wikiContent\" name=\"wikiContent\">" . (isset($data['wikiContent'])?$data['wikiContent']:"") . "</textarea>\n";
		$s .= "</tr>\n";
		// SEO data
		$s .= "<tr>\n";
		$s .= "<td colspan=\"2\">\n";
		$s .= $this->SEOForm($pageID);
		$s .= "</td>\n";
		$s .= "</tr>\n";
		// Comment
		if(((intval($perms)&P_COMMENT)!=0) OR (isset($_SESSION[WIKI_PREFIX.'wsuperadmin']) AND $_SESSION[WIKI_PREFIX.'wsuperadmin']==1)) {
		  $s .= "<tr $hide style=\"".((CONFIG_ALLOW_COMMENTS != "YES")?"display:none":"")."\">\n";
		  $s .= "<td colspan=\"2\"><a href=\"#\" onClick=\"toggleDivDisplay('comment'); return false;\">". str_COMMENT .":</a> <br>\n";
		  $s .= "<div id=\"comment\" style=\"width: 90%;display: none;\">\n";
		  $s .= "<textarea style=\"width:100%;\" id=\"wikiComment\" name=\"wikiComment\" rows=\"10\"></textarea>\n";		  
		  $s .= "</div></td>";
		  $s .= "</tr>";
		}
		// File
		if (((intval($perms)&P_FILEUPLOAD)!=0) OR (isset($_SESSION[WIKI_PREFIX.'wsuperadmin']) AND $_SESSION[WIKI_PREFIX.'wsuperadmin']==1)) {
		  $folder = PRE . $this->userfiles_uploads;
		  if( is_dir($folder) ) {
		    $s .= "<tr $hide style=\"".((CONFIG_ALLOW_UPLOADS != "YES")?"display:none":"")."\">\n";
		    $s .= "<td colspan=\"2\"><a href=\"#\" onClick=\"toggleDivDisplay('attachement'); return false;\">". str_UPLOADFILE .": (< ".ini_get("upload_max_filesize").")</a><br>\n";
		    $s .= "<div id=\"attachement\" style=\"width: 90%;display: none;\">\n";
		    $s .= str_FILETITLE . ": <input type=\"TEXT\" id=\"wikiFileName\" name=\"wikiFileName\" style=\"margin-right: 40px;\">&nbsp;". str_FILENAME .": <input type=\"file\" name=\"wikiFile\" style=\"width: 400px;height: 20px;\">\n";
		    $s .= "<br/><br/>".str_FOLDER."<select name=\"group\">\n";
		    $s .= "<option value=\"\">---------</option>\n";
		    $groups=explode(",",$_SESSION[WIKI_PREFIX.'groups']);
		    foreach ($groups as $g) {
			    $s .= "<option value=\"$g\">$g</option>\n";
		    }
		    $s .= "</select>";
		    $s .= "</div></td>";
		    $s .= "</tr>";
		  }
		  else
		    $s .= "<tr $hide><td colspan=\"2\"><span style=\"color: red;font-weight: bold;\">Upload folder $folder could not be found</span></td></tr>";
		}
		// Changes
		  $s .= "<tr $hide style=\"".((CONFIG_ALLOW_CHANGES != "YES")?"display:none":"")."\">\n";
		  $s .= "<td colspan=\"2\"><a href=\"#\" onClick=\"if (document.getElementById('sendchanges').checked) toggleDivDisplay('changes'); return false;\">" . str_CHANGES . ": </a>";
		  $s .= "&nbsp;<input type=\"checkbox\" id=\"sendchanges\" name=\"sendchanges\" value=\"1\" ";
		  if ((intval($perms)&P_LOGEDIT)==0) $s .= "checked=\"checked\" ";
		  $s .= "onclick=\"";
		  if (($newpage) AND ((intval($perms)&P_LOGEDIT)==0) AND ($_SESSION[WIKI_PREFIX.'wsuperadmin']!=1)) $s .= "this.checked=true; ";
		  $s .= "if (!this.checked) document.getElementById('changes').style.display='none';\"";
		  $s .= "/>&nbsp;".str_SENDCHANGES;
		  $s .= "<br>\n";
		  $s .= "<div id=\"changes\" style=\"width:90%;display: none;\">";
		  $s .= "<textarea rows=\"5\" style=\"width:100%; overflow:auto;\" type=\"text\" id=\"wikiChanges\" name=\"wikiChanges\"></textarea>\n";
		  $s .= "</div></td>\n";
		  $s .= "</tr>\n";
		if( defined("CONFIG_ALLOW_HISTORY") && CONFIG_ALLOW_HISTORY == "YES") {
		// History
		  $s .= "<tr $hide>\n";
		  $s .= "<td colspan=\"2\"><a href=\"#\" onClick=\"toggleDivDisplay('history'); return false;\">" . str_HISTORY . "</a><br>\n";
		  $s .= "<div id=\"history\" style=\"display:none; overflow:auto;width:100%;\">" . (isset($history)?nl2br($history):"") . "</div>\n";
		  //$s .= "<script>document.getElementById('history').style.width=document.getElementById('wikiMenuLabel').style.width;</script>\n";
		  $s .= "</div></td>\n";
		  $s .= "</tr>\n";
		}
		// Superadmin page?			
		if (isset($data['wikiSuperadminPage']) && (int) $data['wikiSuperadminPage'] == 1) {	$checked = " checked"; }
		else { $checked = ""; }
		$s .= "<input type=\"hidden\" id=\"wikiSuperadminPageOrig\" value=\"" . (($checked==" checked")?"true":"false") . "\" />\n";
		if (isset($_SESSION[WIKI_PREFIX.'wsuperadmin']) && $_SESSION[WIKI_PREFIX.'wsuperadmin'] == 1 && $pageID!="wiki") {
			$s .= "<tr>\n";
			$s .= "<th style=\"width:100px;\" valign=\"top\">" . str_SUPERADMINPAGE . "</th>\n";
			$s .= "<td style=\"width:90%\" valign=\"top\">";
			$s .= "<input type=\"checkbox\" name=\"wikiSuperadminPage\" id=\"wikiSuperadminPage\" value=\"1\"" . $checked . " />";
			$s .= " <span style=\"font-weight:normal; font-size:10px;\">(" . str_SUPERADMINPAGEDESC . ")</span>\n";
			$s .= "</td>\n";
			$s .= "</tr>\n";
		}

		// Submit
		$s .= "<tr>\n";
		$s .= "<td colspan=\"2\"><input type=\"hidden\" id=\"pageID\" name=\"pageID\" value=\"" . (($pageID!="-1")?$pageID:$_SESSION[WIKI_PREFIX."newPageId"]) . "\" />\n";
		if (!isset($data['wikiModule']) || $data['wikiModule']=="") {
			$s .= "<input class=\"wikiButton\" type=\"button\" name=\"submitWiki\" value=\"" . str_SUBMIT . "\" onclick=\"submitWikiForm()\" />&nbsp;&nbsp;\n";
			$s .= "<input class=\"wikiButton\" type=\"button\" name=\"cancelWiki\" value=\"" . str_CANCEL . "\" onClick=\"editingPage=false;ieCrashFix(); " . (($pageID=='-1')?"tree.deleteItem(newItemId); newItemId=-1; openItem(selectedId,true)\"":"unLockFile('" . $pageID . "');openItem(selectedId,true);\" />\n");
		}
		$s .= "</td>\n";
		$s .= "</tr>\n";
		$s .= "</table>\n";
		$s .= $this->spamTrapFields();
		$s .= "</form>\n";
		return $s;
	}
	
	function commentsForm($pageID='-1',$perms) {
		if ((CONFIG_ALLOW_COMMENTS == "YES" OR CONFIG_ALLOW_UPLOADS == "YES") AND ((((intval($perms)&P_COMMENT)!=0) AND ($pageID!=-1)) OR (isset($_SESSION[WIKI_PREFIX.'wsuperadmin']) AND $_SESSION[WIKI_PREFIX.'wsuperadmin']==1))) {
		$s = "<div style=\"margin-top: 20px;\"><input type=\"button\" class=\"wikiButton\" value=\"".str_ADD_COMMENTS."\" onClick=\"toggleDivDisplay('addComments'); document.getElementById('wikiComment').focus()\"/>";
		$s .= "<div id=\"addComments\" style=\"margin-top: 10px; display: none;\">\n";
		$s .= "<form name=\"wikiCommentForm\" action=\"ajax/addComment.php\" method=\"post\" target=\"actionFrame\" enctype=\"multipart/form-data\">\n";		
		$s .= "<table class=\"wikiForm\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\">\n";
		if( ((intval($perms)&P_COMMENT)!=0 ) OR ($_SESSION[WIKI_PREFIX.'wsuperadmin']==1)) {
		  $s .= "<tr style=\"".((CONFIG_ALLOW_COMMENTS != "YES")?"display:none":"")."\">\n";
		  $s .= "<td colspan=\"2\"><a href=\"#\" onClick=\"toggleDivDisplay('comment'); return false;\">". str_COMMENT .":</a> <br>\n";
		  $s .= "<input type=\"hidden\" name=\"pageID\" value=\"$pageID\" />";
		  $s .= "<div id=\"comment\" style=\"width: 90%;display: block;\">\n";
		  $s .= "<textarea style=\"width:100%;\" id=\"wikiComment\" name=\"wikiComment\" rows=\"10\"></textarea>\n";
		  $s .= "<input type=\"hidden\" name=\"pageID\" value=\"".$pageID."\"/>\n";
		  $s .= "</div></td>";
		  $s .= "</tr>";
		}
		// File
		
		if (CONFIG_ALLOW_UPLOADS == "YES" AND ( ((intval($perms)&P_FILEUPLOAD)!=0 ) OR (isset($_SESSION[WIKI_PREFIX.'wsuperadmin']) AND $_SESSION[WIKI_PREFIX.'wsuperadmin']==1))) {
		  $folder = PRE . $this->userfiles_uploads;
		  if( is_dir($folder) ) {
		    $s .= "<tr>\n";
		    $s .= "<td colspan=\"2\"><a href=\"#\" onClick=\"toggleDivDisplay('attachement'); return false;\">". str_UPLOADFILE .": (< ".ini_get("upload_max_filesize").")</a><br>\n";
		    $s .= "<div id=\"attachement\" style=\"width: 90%;display: none;\">\n";
		    $s .= str_FILETITLE . ": <input type=\"TEXT\" id=\"wikiFileName\" name=\"wikiFileName\" style=\"margin-right: 40px;\">&nbsp;". str_FILENAME .": <input type=\"file\" name=\"wikiFile\" style=\"width: 400px;height: 20px;\">\n";
		    $s .= "<br/><br/>".str_FOLDER."<select name=\"group\">\n";
		    $s .= "<option value=\"\">---------</option>\n";
		 	if (isset($_SESSION[WIKI_PREFIX.'groups']) AND $_SESSION[WIKI_PREFIX.'groups']!="") {
		    $groups=explode(",",$_SESSION[WIKI_PREFIX.'groups']);
			    foreach ($groups as $g) {
				    $s .= "<option value=\"$g\">$g</option>\n";
			    }
		    }
		    $s .= "</select>";
		    $s .= "</div></td>";
		    $s .= "</tr>";
		  }
		  else
		    $s .= "<tr><td colspan=\"2\"><span style=\"color: red;font-weight: bold;\">Upload folder $folder could not be found</span></td></tr>";
		}

		// Submit
		$s .= "<tr>\n";
		$s .= "<td colspan=\"2\">\n";
		$s .= "<input class=\"wikiButton\" type=\"submit\" name=\"submitWiki\" value=\"" . str_SUBMIT . "\" />&nbsp;&nbsp;\n";
		$s .= "<input class=\"wikiButton\" type=\"button\" name=\"cancelWiki\" value=\"" . str_CANCEL . "\" onClick=\"unLockFile('" . $pageID . "'); getPage(tree.getSelectedItemId());\" />\n";
		$s .= "</td>\n";
		$s .= "</tr>\n";
		$s .= "</table>\n";
		// spam trap
		$s .= $this->spamTrapFields();
		$s .= "</form>\n";
		$s .= "</div></div>\n";
		return $s;
		} else {
			return "";
		}
	}
	
	function spamTrapFields() {
		$s = "<div style=\"display: none\"><input type=\"text\" id=\"wikiComment1\" name=\"wikiComment1\" value=\"\" /><textarea name=\"wikiComment2\"  id=\"wikiComment2\" rows=\"10\" cols=\"10\"></textarea></div>\n";
		return $s;
	}
	
	function isSpam($data) {
		if (!isset($data['wikiComment1']) OR !isset($data['wikiComment2'])) return true;
		if (isset($data['wikiComment1']) AND $data['wikiComment1']!=WIKI_PREFIX) return true;
		if (isset($data['wikiComment2']) AND $data['wikiComment2']!="") return true;
		return false;
	}
	
	function addSpamFields($data) {
		if (!isset($data['wikiComment1'])) $data['wikiComment1'] = WIKI_PREFIX;
		if (!isset($data['wikiComment2'])) $data['wikiComment2'] = "";
		return $data;
	}
	
	/**
	 * Display page
	 *
	 * @param string $pageID
	 * @return string
	 */
	function wikiPage($pageID,$perms=false,$printComments=true,$forseo=false) {
		if ($perms===false) $perms=isset($_SESSION[WIKI_PREFIX."wp_".$pageID])?$_SESSION[WIKI_PREFIX."wp_".$pageID]:0;
		// special page IDs
		if ($pageID == 'null') $pageID = "wiki";
		elseif ($pageID == -1) return "";
		// load page data
		$data = $this->loadPage($pageID);
		// is module page?
		if (isset($data['wikiModule'])) {
			$mod=trim($data['wikiModule']);
			if ($mod!="") {
				$s=$this->loadModule($mod,$pageID);
				$s.="<div style=\"display: none\">###THIS IS WIKI MODULE PAGE###</div>";
				return $s;
			}
		}
		
		// superadmin page and not logged in as superadmin				
		if (isset($data['wikiSuperadminPage']) && $data['wikiSuperadminPage'] == 1 && ((isset($_SESSION[WIKI_PREFIX.'wsuperadmin']) && $_SESSION[WIKI_PREFIX.'wsuperadmin'] != 1) || (!isset($_SESSION[WIKI_PREFIX.'wsuperadmin'])))) {
			$s = str_PLEASELOGINTOVIEW;
		}
		elseif ($data['wikiContent']) {
			$s = $data['wikiContent'];
		}
		else {
			$s = "";
		}
		
		if (!$forseo) $s=$this->Pageid2AJAX($s);
		
		if( ((defined("CONFIG_ALLOW_COMMENTS") && CONFIG_ALLOW_COMMENTS == "YES") || 
			(defined("CONFIG_ALLOW_UPLOADS") && CONFIG_ALLOW_UPLOADS == "YES")) && $printComments) {	
		  
		  $havecomments = NULL;
		  $comments = $data['wikiComment'];
		  for( $i = 0; $i < count($comments); $i++) {
			if( strstr($comments[$i], "|") ) {
				$pos = strpos($comments[$i], '|');
				$tmp = substr($comments[$i], ($pos+1));
				if( strlen(trim($tmp)) > 0 ) {
					$havecomments = 1;
					break;
				}
			}
		  }

		  if( $havecomments ) {
		    $s .= '<p><span style="margin-top: 10px;margin-bottom: 5px;font-weight: bold;">'. str_COMMENTLIST .'</span>';
		    $s .= '<br><table cellpadding="0" cellspacing="0" border="0"  style="width: 75%;">';
		  }
		  
		  
		  for($i = 0; $i < count($comments); $i++) {
		  	$time_tmp=explode("|",$comments[$i]);
			$delComm="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type=\"button\" class=\"wikiButton\" value=\"".str_DELETE_COMMENT."\" onclick=\"deleteComment('".$time_tmp[0]."')\" />";
		  	$s .= "<tr>";
		  	if (preg_match_all("/<!-- FILES Start -->(.*?)<!-- FILES End -->/",$comments[$i],$files)) {
		  	  $tmp = substr($comments[$i], 0, strpos($comments[$i], "<!-- FILES Start -->"));
		  	  if( ($tmp && defined("CONFIG_ALLOW_COMMENTS") && CONFIG_ALLOW_COMMENTS == "YES") || ($tmp && defined("CONFIG_ALLOW_UPLOADS") && CONFIG_ALLOW_UPLOADS == "YES")) {
		  	    $pos = strpos($tmp, "|");
		  	    
		  	    if( LANGUAGE == "deutsch" ) {
		  	      $date = date("d.m.Y H:i", substr($tmp, 0, $pos));
			      $content = "<em style=\"font-size: 8pt;\">" . $date . " Uhr</em>";
			      if ($_SESSION[WIKI_PREFIX.'wsuperadmin'] == 1) $content.=$delComm;
				  if( defined("CONFIG_ALLOW_COMMENTS") && CONFIG_ALLOW_COMMENTS == "YES" )
				    $content .= "<div class=\"simpleComment\">" .htmlspecialchars(substr($tmp, $pos + 1),ENT_QUOTES) . "</div>";
			    }
			    else {
			      $date = date("Y-m-d h:i a", substr($tmp, 0, $pos));
			      $content = "<em style=\"font-size: 8pt;\">" . $date . "</em>";
			      if ($_SESSION[WIKI_PREFIX.'wsuperadmin'] == 1) $content.=$delComm;
			      if( defined("CONFIG_ALLOW_COMMENTS") && CONFIG_ALLOW_COMMENTS == "YES" )
				    $content .= "<div class=\"simpleComment\">" . htmlspecialchars(substr($tmp, $pos + 1),ENT_QUOTES) . "</div>";
			    }
			  }
			  else
			    $content = NULL;
			    
		  	  $s .= '<td style="padding-bottom: 5px;"><div class="wikiComment">';
              $s .= $content;
              
		  	  if( $files[1][0] && defined("CONFIG_ALLOW_UPLOADS") && CONFIG_ALLOW_UPLOADS == "YES") {
		  	  	if( strstr($files[1][0],"|") ) {
		  	  	  $name = substr($files[1][0], 0, strpos($files[1][0], "|"));
		  	  	  $file = substr($files[1][0], strpos($files[1][0], "|") + 1);
		  	      $files = '<p class="wikiAttachement"><a href="'.$this->userfiles_uploads . $file .'" target="_blank">'.htmlspecialchars($name,ENT_QUOTES,"UTF-8"). '</a></p>';
		  	    }
		  	    else
		  	      $files = '<p class="wikiAttachement"><a href="'.$this->userfiles_uploads . $files[1][0] .'" target="_blank">'.htmlspecialchars($files[1][0],ENT_QUOTES,"UTF-8"). '</a></p>';
		  	  }
		      else
		        $files = NULL;
			  $s .= $files . '</div></td>';
		      $s .= "</tr>";
		  	}
		  	else {
		  	  if( $comments[$i] ) {
		  	  	$tmp = $comments[$i];
		  	  	$pos = strpos($tmp, "|");
		  	  	if( defined("CONFIG_ALLOW_COMMENTS") && CONFIG_ALLOW_COMMENTS == "YES") {
		  	      if( LANGUAGE == "deutsch" ) {
		  	        $date = date("d.m.Y H:i", substr($tmp, 0, $pos));
		  	        $content = substr($tmp, $pos + 1);
		  	        if( $content ) {
			          $content_tmp = "<em style=\"font-size: 8pt;\">" . $date . " Uhr</em>";
			      	  if (isset($_SESSION[WIKI_PREFIX.'wsuperadmin']) AND $_SESSION[WIKI_PREFIX.'wsuperadmin'] == 1) $content_tmp.=$delComm;
			          $content=$content_tmp."<div class=\"simpleComment\">" . htmlspecialchars($content,ENT_QUOTES) ."</div>";
			        } else {
			          $content = NULL;
			        }
			      }
			      else {
			        $date = date("Y-m-d h:i a", substr($tmp, 0, $pos));
			        $content = substr($tmp, $pos + 1);
		  	        if( $content ) {
			          $content_tmp = "<em style=\"font-size: 8pt;\">" . $date . "</em>";
			      	  if (isset($_SESSION[WIKI_PREFIX.'wsuperadmin']) AND $_SESSION[WIKI_PREFIX.'wsuperadmin'] == 1) $content_tmp.=$delComm;
			          $content=$content_tmp."<div class=\"simpleComment\">" . htmlspecialchars($content,ENT_QUOTES) ."</div>";
			        } else {
			          $content = NULL;
			        }
			      }
			    }
			    else
			      $content = NULL;
			  }
			  else
		  	    $content = "";
		  	  if( $content ) {
			    $s .= '<td style="padding-bottom: 5px;"><div class="wikiComment">'.$content.'</div></td>';
		        $s .= "</tr>";
		      }
		      else
		        $s .= '<td style="display: none;"></td>';
			}
		  }
		  $s .= "</table></p>";
		}
		if ($printComments) $s .= $this->commentsForm($pageID,$perms);
		return $s;
	}
	
	/**
	 * Generate language dependend context.xml
	 *
	 */
	function generateContextXML() {
		$s = "<?xml version='1.0' encoding='UTF-8' ?>\n";
		$s .= "<menu>\n";
		$s .= "<item text=\"" . cntxt_COLLAPSE . "\" id=\"collapse\" />\n";
		$s .= "<item text=\"" . cntxt_SORT . "\" id=\"sort\" />\n";
		$s .= "<item text=\"" . cntxt_ADD . "\" id=\"add\" />\n";
		$s .= "<item text=\"" . cntxt_EDIT . "\" id=\"edit\" />\n";
		$s .= "<item text=\"" . cntxt_DELETE . "\" id=\"delete\" />\n";
		$s .= "<item text=\"" . cntxt_PRINT . "\" id=\"print\" />\n";
		$s .= "<item text=\"" . cntxt_CHANGE_PASSWORD . "\" id=\"changepass\" />\n";
		$s .= "<item text=\"" . cntxt_SETTINGS . "\" id=\"settings\" />\n";
		$s .= "<item text=\"" . cntxt_PRIVILEGES . "\" id=\"privileges\" />\n";
		$s .= "</menu>\n";
		return $s;
	}

	function writeDefaultMenuXML() {
		if ($this->defaultXMLwritten) return;
		$db=new Database();
		$db->create("tree","uniqueid,id,parent,order,text,userdata");
		$oldTree=$this->unserializeTree(false,true);
		if ($oldTree!==false) {
			$db->drop("tree");
			$db->create("tree","uniqueid,id,parent,order,text,userdata");
			//old menu to db
			$order=array();
			foreach ($oldTree as $item) {
				$data=array();
				if (!isset($order[$item['parent']])) $order[$item['parent']]=0;
				$data['id']=$item['id'];
				$data['parent']=$item['parent'];
				$data['order']=$order[$item['parent']];
				$data['text']=$item['text'];
				$data['userdata']="sa:".$item['sa'];
				$db->add_row("tree", $db->makeQuery($data));
				$order[$item['parent']]++;
			}
			@rename(PRE . $this->userfiles_menu . $this->menu_filename,PRE . $this->userfiles_menu . str_replace(".",time().".",$this->menu_filename) . "old");
			$this->tree=$this->unserializeTree(true);
			foreach ($this->tree as $t) {
				$data=array();
				$data['userdata']=$this->setUserData("levels",$this->nodeLevels($t['id']),$t['userdata']);
				$db->update("tree",$db->makeQuery($data),"id=".$t['id']);
			}
		} else {
			$db->query("tree","","id=wiki");
			if ($db->num_rows()==0) {
				//default menu
				$data=array();
				$data['id']="wiki";
				$data['parent']="0";
				$data['order']=0;
				$data['text']=str_HOMEPAGE;
				$data['userdata']="sa:0,levels:0";
				$db->add_row("tree", $db->makeQuery($data));
			}
		}
		$this->defaultXMLwritten=true;
	}
	
	function getUserData($find,$userdata) {
		$ret="";
		if (isset($this->usersdata[$find])) $ret=$this->usersdata[$find];
		$userdatatmp=explode(",",$userdata);
		foreach ($userdatatmp as $ud) {
			$tmp=explode(":",$ud);
			if ($tmp[0]==$find && isset($tmp[1])) {
				$ret=$tmp[1];
				break;
			}
		}
		return $ret;
	}
	
	function setUserData($set,$val,$userdata) {
		$ret=array();
		$userdatatmp=explode(",",$userdata);
		foreach ($userdatatmp as $ud) {
			$tmp=explode(":",$ud);
			if (isset($tmp[1]) && in_array($tmp[0],array_keys($this->usersdata))) {
				$ret[$tmp[0]]=$tmp[1];
			} else if (isset($this->usersdata[$tmp[0]])) {
				$ret[$tmp[0]]=$this->usersdata[$tmp[0]];
			}
		}
		foreach ($this->usersdata as $key=>$ud) {
			if (!isset($ret[$key])) $ret[$key]=$ud;
		}
		if (is_array($ret)) {
			$ret[$set]=$val;
			$tmpret=array();
			foreach ($ret as $key=>$val) {
				$tmpret[]=$key.":".$val;
			}
			$ret=implode(",",$tmpret);
		}
		return $ret;
	}
	
	function levelCount($id,$parent=0,$parents=array()) {
		$item=$this->tree[$id];
		if (isset($item['children']) && $item['children']!="") {
			$this->maxlevels[$id]=1;
			if ($parent!=0 && !in_array($parent,$parents)) {
				$parents[]=$parent;
				$this->maxlevels[$parent]++;
			}
			$children=explode(",",$item['children']);
			foreach ($children as $child) {
				$this->levelCount($child,$id,$parents);
			}
		}
	}
	
	function treeXML($userid=-1) {
		$id=(isset($_REQUEST['id'])?$_REQUEST['id']:0);
		$s = "<?xml version=\"1.0\"?>";
		$s .= "<tree id=\"".$id."\">";
		$s .=$this->treeItem($id,false,$userid);
		$s .= "</tree>";
		$this->idRefreshed($id);
		return $s;
	}
	
	function treeItem($id,$nochildren=false,$userid=-1) {
		$user="loggedUser";
		if ($userid!=-1) {
			$db=new Database();
			$db->query("users","","userid=".$userid);
			while ($row=$db->fetch_row()) {
				$user=$row['email'];
			}
		}
		if ($id=="0") {
			$id="wiki";
			$nochildren=true;
		}
		$item=$this->tree[$id];
		$tmp=array();
		$children=array();
		if (isset($item['children']) && $item['children']!="") $children=explode(",",$item['children']);
		foreach ($children as $child) {
			if ($this->isUserPage($child,$user,true,P_READ)) $tmp[]=$child;
		}
		$children=$tmp;
		$s="";
		if ($nochildren) {
			$s.="<item ";
			$s.="id=\"".$item['id']."\" ";
			if ($id=="wiki") $s.=" select=\"1\"";
			if ($id=="wiki") $s.=" open=\"1\"";
			$s.=" tooltip=\"".$this->xmlentities(stripslashes($item['text']));
			if ($this->loggedUserId()!="" && $this->isPublic($item['id'])) $s.=" (Public)";
			$s.="\"";
			$s.=" order=\"".$item['order']."\"";
			$s.=" child=\"".((count($children)>0)?1:0)."\"";
			$s.=" text=\"".$this->xmlentities(stripslashes($item['text']))."\"";
			$s.=" im0=\"".(($item['id']=="wiki")?"books_close.gif":"leaf_closed.gif")."\"";
			$s.=" im1=\"".(($item['id']=="wiki")?"books_open.gif":"leaf_open.gif")."\"";
			$s.=" im2=\"".(($item['id']=="wiki")?"books_open.gif":"leaf_closed.gif")."\"";
			$s.=" aCol=\"".COLOR_FRONT."\"";
			$s.=" sCol=\"".COLOR_BACK."\"";
			$s.=">";
			foreach ($this->usersdata as $ud=>$def) {
				$s.="<userdata name=\"".$ud."\">".$this->getUserData($ud,$item['userdata'])."</userdata>";
			}
			$s.="</item>";
		} else {
			foreach ($children as $child) {
				$s.=$this->treeItem($child,true,$userid);
			}
		}
		return $s;
	}
	
	function nodeLevels($id) {
		$this->levelCount($id);
		return $this->maxlevels[$id];
	}
	
	function unserializeTreeFromDb($keepassoc=false) {
		$ret=array();
		$tmpret=array();
		$db=new Database();
		$db->query("tree");
		$fix=array();
		while ($row=$db->fetch_row()) {
			if ($row['parent']==$row['id']) $fix[]=$row['id'];
			if (count($fix)==0) {
				foreach ($this->usersdata as $u=>$default) {
					$row[$u]=$this->getUserData($u,isset($row['usersdata'])?$row['usersdata']:"");
				}
			}
			$tmpret[$row['id']]=$row;
		}
		
		foreach ($tmpret as $id=>$item) {
			$tmpret[$id]['children']=$this->getChildren($id);
			if (in_array($tmpret[$id]['parent'],explode(",",$tmpret[$id]['children']))) $fix[]=$id;
		}

		if (count($fix)>0) {
			foreach ($fix as $id) {
				$data=array();
				$data['parent']="wiki";
				$db->update("tree",$db->makeQuery($data),"id=".$id);
			}
			return $this->unserializeTreeFromDb($keepassoc);
		}
		
		foreach ($tmpret as $item) {
			if (isset($item['id'])) {
				$this->maxlevels[$item['id']]=0;
				if (!$keepassoc) {
					$ret[]=$item;
				} else {
					$ret[$item['id']]=$item;
				}
			}
		}
		return $ret;
	}

	function getChildren($parent) {
		$db=new Database();
		$children=array();
		$db->query("tree","","parent=".$parent,"order/ASCN");
		while ($row=$db->fetch_row()) {
			$children[]=$row['id'];
		}
		return implode(",",$children);
	}

	/**
	 * Write .htaccess
	 *
	 */
	function writeHtaccess() {
		$s = "AuthType Basic\n";
		$s .= "AuthUserFile " . $_SERVER['DOCUMENT_ROOT'] . substr($_SERVER['PHP_SELF'],0,strrpos($_SERVER['PHP_SELF'],"/")) . "/UserFiles/Pages/.htpasswd\n";
		$s .= "AuthName \"".PRODUCT."\"\n\n";
		$s .= "order deny,allow\n";
		$s .= "allow from all\n";
		$s .= "require valid-user\n";
		
		if (!file_exists($this->userfiles_pages . ".htaccess")) $this->writeFile($s,$this->userfiles_pages . ".htaccess");
		if (!file_exists($this->userfiles_changes . ".htaccess")) $this->writeFile($s,$this->userfiles_changes . ".htaccess");
		if (!file_exists($this->userfiles . "tmp/.htaccess")) $this->writeFile($s,$this->userfiles . "tmp/.htaccess");
		//if (!file_exists($this->userfiles_menu . ".htaccess")) $this->writeFile($s,$this->userfiles_menu . ".htaccess");
	}
	
	/**
	 * Write .htpasswd
	 *
	 */
	function writeHtpasswd() {
		if (defined("SUPERPASSWORD") && SUPERPASSWORD != "") {		
			$s = "admin:" . crypt(SUPERPASSWORD) . "n";
		} elseif (defined("PASSWORD") && PASSWORD != "") {
			$s = "admin:" . crypt(PASSWORD) . "n";
		}
		$this->writeFile($s,$this->userfiles_pages . ".htpasswd");
	}
	
	/**
	 * Write file
	 *
	 * @param string $string
	 * @param string $path
	 */
	function writeFile($string,$path) {
		$fp = @fopen(PRE . $path, "w");
		if ($fp) {
			flock($fp,2);
			fputs($fp,$string);
			flock($fp,3);
			fclose($fp);
		}
	}
	
	/**
	 * Write XML stream to file
	 *
	 * @param string $xml
	 * @param string $filename
	 */
	function writeXML($xml,$filename) {
		$write=false;
		$error="";
		if ($filename!="menu.xml") {
			if ($xml!="") $write=true;
		} else {
			if ($xml!="") {
				$write=true;
				$tags=array("tree","item","userdata");
				foreach ($tags as $t) {
					$opentags=substr_count($xml,"<".$t);
					$closedtags=substr_count($xml,"</".$t);
					if ($t!="userdata" AND (($opentags==0) OR ($closedtags==0) OR ($opentags!=$closedtags))) {
						$write=false;
						$error="Incorrect XML write: tag $t is not closed properly!";
						break;
					} else if ($t=="userdata" AND $opentags!=$closedtags) {
						$write=false;
						$error="Incorrect XML write: tag $t is not closed properly!";
						break;
					}
				}
			}
		}
		if ($write) {
			$fp = @fopen(PRE . $this->userfiles_menu . $filename, "w");
			if ($fp) {
				flock($fp,2);
				fputs($fp,stripslashes($xml));
				flock($fp,3);
				fclose($fp);
			} else {
				$error="Could not open $filename for writing";
			}
		}
		return $error;
	}
	
	function lockXML($filename) {
		$fp = @fopen(PRE . $this->userfiles_menu . $filename . ".lock", "w");
		if ($fp) {
			flock($fp,2);
			fputs($fp,"1");
			flock($fp,3);
			fclose($fp);
		}
	}
	
	function unLockXML($filename) {
		if (file_exists(PRE . $this->userfiles_menu . $filename . ".lock")) unlink(PRE . $this->userfiles_menu . $filename . ".lock");
	}

	function canWriteXML($filename) {
		if (file_exists(PRE . $this->userfiles_menu . $filename . ".lock")) {
			clearstatcache();
			if (filemtime(PRE . $this->userfiles_menu . $filename . ".lock")<(time()-MAX_LOCK_TIME)) {
				$this->unlockXML($filename);
				return "YES";
			} else {
				return "NO";
			}
		} else {
			return "YES";
		}
	}
	
	/**
	 * Save page contents to file
	 *
	 * @param array $data
	 */
	function savePage($data,$justcomment='',$fixseo=false) {
		if (!$this->isSpam($data) || $fixseo) {
			$this->saveSEOData($data);	
			// save page
			$sendchanges=false;
			if ($data['pageID']=="wiki") $data['wikiSuperadminPage']=0;
			if ($data['sendchanges']=="1") $sendchanges=true;
			$data['wikiComment']=str_replace("\n","<br/>",$data['wikiComment']);
			$filename = $data['pageID'] . ".wiki";
			$content = "<!-- LABEL Start -->";
			$data['wikiMenuLabel']=$data['wikiMenuLabel'];
			$content .= $data['wikiMenuLabel'];
			$content .= "<!-- LABEL End -->\n";
			$content .= "<!-- SA Start -->";		
			$content .= (isset($data['wikiSuperadminPage']))?((int) $data['wikiSuperadminPage']):"0";
			$content .= "<!-- SA End -->\n";
			$content .= "<!-- CONTENT Start -->";
			$content .= $data['wikiContent'];
			$content .= "<!-- CONTENT End -->\n";
			if (!isset($data['wikiModule']) OR $data['wikiModule']==-1) {
				$content.="<!-- MODULE Start --><!-- MODULE End -->\n";
			} else {
				$content.="<!-- MODULE Start -->".$data['wikiModule']."<!-- MODULE End -->\n";
			}
			
			$str = file_get_contents(PRE . $this->userfiles_pages . $filename);
			$s = "";
			if (preg_match_all("/<!-- COMMENT Start -->(.*?)<!-- COMMENT End -->/",$str,$regs)) {
				$regs = $regs[1];
				for($i = 0; $i < count($regs); $i++) {
	     		  $s .= "<!-- COMMENT Start -->" . $regs[$i] . "<!-- COMMENT End -->\n";
				}
			}		
			$content .= $s;
			if (!$fixseo) {
				$content .= "<!-- COMMENT Start -->";
				$date = strtotime(date("Y-m-d H:i:s"));
				$content .= ( $data['wikiComment'] != NULL ) ? $date ."|".$data['wikiComment'] : $date . "|";
				if( isset($_FILES['wikiFile']) && !empty($_FILES['wikiFile']['tmp_name']) && substr($_FILES['wikiFile']['name'],strrpos($_FILES['wikiFile']['name'],"."),4)!=".php") {
					// change not allowed signs in filename
					$signs = array("\"", "\'", "", "\$", "&", "/", "(", ")", "=", "?", "%", "@", "*", "#", ":", ";", ",", "<", ">", "!", "+", " ");
					$tmpname = rawurldecode($_FILES['wikiFile']['name']);
					for($i = 0;$i < count($signs); $i++)
					  $tmpname = str_replace($signs[$i], "", $tmpname);
					$tmpname = str_replace("", "ae", $tmpname);
					$tmpname = str_replace("", "oe", $tmpname);
					$tmpname = str_replace("", "ue", $tmpname);
					$tmpname = str_replace("", "ss", $tmpname);
					$tmpname = str_replace(" ", "_", $tmpname);
					
					// add timestamp to filename			
					$file = $data['group'] . "/" . time()."_". $tmpname;
					$path = "../" . $this->userfiles_uploads . $file;
					move_uploaded_file($_FILES['wikiFile']['tmp_name'], $path);
					$content .= "<!-- FILES Start -->";
					if( !empty($data['wikiFileName']) )
					  $content .= $data['wikiFileName'] . "|";
					$content .= $file . "<!-- FILES End -->";
					$sendchanges=true;
				}
				$content .= "<!-- COMMENT End -->\n";
			}
			$fp = @fopen(PRE . $this->userfiles_pages . $filename, "w");
			if (!$fp) {
				echo "<script>parent.displaySystemMessage(\"" . htmlentities(err_PAGENOTWRITEABLE,ENT_QUOTES,"utf-8") . "\");</script>";
				echo "<script>parent.logError(\"" . addslashes(err_PAGENOTWRITEABLE) . "\");</script>";
			} else {
				flock($fp,2);
				fputs($fp,stripslashes($content));
				flock($fp,3);
				fclose($fp);
			}
			// save history
			if (($sendchanges) && ($justcomment=='') && !$fixseo) {
				$filename = $data['pageID'] . ".log";
				$content = date("Y-m-d H:i:s") . ":\n";
				$content .= (($data['wikiChanges']!="")?$data['wikiChanges']:" - " . str_UNDOCUMENTED . " -")."\n";
				$username=str_GUEST;
				if (isset($_SESSION[WIKI_PREFIX.'wusername']) AND ($_SESSION[WIKI_PREFIX.'wusername']!="")) $username=$_SESSION[WIKI_PREFIX.'wusername'];
				$content .= str_USERNAME.": ".$username; 
				$content .= "\n\n";
				$fp = @fopen(PRE . $this->userfiles_changes . $filename, "a+");
				if (!$fp) {
					echo "<script>parent.displaySystemMessage(\"" . htmlentities(err_HISTORYNOTWRITABLE,ENT_QUOTES,"utf-8") . "\");</script>";
					echo "<script>parent.logError(\"" . addslashes(err_HISTORYNOTWRITABLE) . "\");</script>";
				} else {
					flock($fp,2);
					fputs($fp,stripslashes($content));
					flock($fp,3);
					fclose($fp);
				}
			}
		}
		// delete lock file
		$this->unlockFile(PRE . $this->userfiles_pages . $data['pageID'] . ".lock");
	}

	function updatePage($data) {
		if (!$this->isSpam($data)) {		
			$this->saveSEOData($data);	
			// save page
			$filename = $data['pageID'] . ".wiki";
			$content = "<!-- LABEL Start -->";
			$data['wikiMenuLabel']=$data['wikiMenuLabel'];
			$content .= $data['wikiMenuLabel'];
			$content .= "<!-- LABEL End -->\n";
			$content .= "<!-- SA Start -->";		
			$content .= (isset($data['wikiSuperadminPage']))?((int) $data['wikiSuperadminPage']):"0";
			$content .= "<!-- SA End -->\n";
			$content .= "<!-- CONTENT Start -->";
			$content .= $data['wikiContent'];
			$content .= "<!-- CONTENT End -->\n";
			
			$comments=$data['wikiComment'];
			if (count($comments)>0) {
				foreach ($comments as $comm_tmp) {
	   				$content .= "<!-- COMMENT Start -->" . $comm_tmp . "<!-- COMMENT End -->\n";
				}		
			}
			
			$fp = @fopen(PRE . $this->userfiles_pages . $filename, "w");
			if (!$fp) {
				echo "<script>parent.displaySystemMessage(\"" . htmlentities(err_PAGENOTWRITEABLE,ENT_QUOTES,"utf-8") . "\");</script>";
				echo "<script>parent.logError(\"" . addslashes(err_PAGENOTWRITEABLE) . "\");</script>";
			} else {
				flock($fp,2);
				fputs($fp,stripslashes($content));
				flock($fp,3);
				fclose($fp);
			}
			// save history
			$filename = $data['pageID'] . ".log";
			$content = date("Y-m-d H:i:s") . ":\n";
			$content .= (($data['wikiChanges']!="")?$data['wikiChanges']:" - " . str_UNDOCUMENTED . " -") . "\n\n";
			$fp = @fopen(PRE . $this->userfiles_changes . $filename, "a+");
			if (!$fp) {
				echo "<script>parent.displaySystemMessage(\"" . htmlentities(err_HISTORYNOTWRITABLE,ENT_QUOTES,"utf-8") . "\");</script>";
				echo "<script>parent.logError(\"" . addslashes(err_HISTORYNOTWRITABLE) . "\");</script>";
			} else {
				flock($fp,2);
				fputs($fp,stripslashes($content));
				flock($fp,3);
				fclose($fp);
			}
			// delete lock file
			//$this->unlockFile(PRE . $this->userfiles_pages . $data['pageID'] . ".lock");
		}
	}


	/**
	 * Save change timestamp
	 *
	 * @return string
	 */
	function saveChangestamp() {
		$content = time();
		$fp = @fopen(PRE . $this->userfiles_changes . $this->changelog_filename, "w");
		if (!$fp) {
			return array("",err_CHANGESTAMPNOTWRITEABLE);
		} else {
			flock($fp,2);
			fputs($fp,$content);
			flock($fp,3);
			fclose($fp);
			return array($content,"");
		}
		return $content;
	}
	
	/**
	 * Read change timestamp
	 *
	 * * @return array
	 */
	function readChangestamp() {
		$content = time();
		$filename = PRE . $this->userfiles_changes . $this->changelog_filename;
		$file = array();
		if (!file_exists($filename)) {
			$fp = @fopen($filename, "w");
			fclose($fp);
		}
		if (file_exists($filename)) {
			$file = file($filename);
			if (is_array($file) && isset($file[0])) {
				return array($file[0],"");
			} else {
				return array(time(),"");
			}
		} else {
			return array("",err_CHANGESTAMPNOTFOUND);
		}
	}
	
	/**
	 * Read history
	 *
	 * @param string $pageID
	 * @return string
	 */
	function loadHistory($pageID) {
		$file = PRE . $this->userfiles_changes . $pageID . ".log";
		$string = "";
		if (file_exists($file)) {
			$history = file($file);
			foreach ($history as $row) {
				$string .= $row;
			}
		} else {
			//echo "parent.displaySystemMessage(\"" . htmlentities(err_HISTORYNOTFOUND,ENT_QUOTES,"utf-8") . "\");";
			//echo "parent.logError(\"" . addslashes(err_HISTORYNOTFOUND) . "\");";
		}
		return $string;
	}
	
	/**
	 * Delete page (file)
	 *
	 * @param string $pageID
	 */
	function deletePage($pageID) {
		if ($pageID=="") return;
		$this->deleteModulePage($pageID);
		$path_pages = PRE . $this->userfiles_pages . $pageID . ".wiki";
		$path_changes = PRE . $this->userfiles_changes . $pageID . ".log";
		if (file_exists($path_pages)) {
			@unlink ($path_pages);
		}
		if (file_exists($path_changes)) {
			@unlink ($path_changes);
		}
		$db=new Database();
		$db->delete("pages","pageid=$pageID");
		$db->delete("urls","pageid=$pageID");
		$db->delete("keywords","pageid=$pageID");
		$db->delete("descriptions","pageid=$pageID");
	}
	
	/**
	 * Read page content
	 *
	 * @param string $pageID
	 * @return array
	 */
	function loadPage($pageID) {
		$filename = $pageID . ".wiki";
		$path = PRE . $this->userfiles_pages . $filename;
		$data = array();
		$s = "";
		// parse page
		if (file_exists($path)) {
			$file = @file($path);
			for($i = 0; $i<count($file); $i++){
			  $s .= trim($file[$i]);
			}
			// get label
			if (preg_match("/<!-- LABEL Start -->(.*?)<!-- LABEL End -->/",$s,$regs)) {
				$data['wikiMenuLabel'] = $regs[1];
			}
			// get superadmin level													
			if (preg_match("/<!-- SA Start -->(.*?)<!-- SA End -->/",$s,$regs)) {
				$data['wikiSuperadminPage'] = (int) $regs[1];
			}
			// get content
			if (preg_match("/<!-- CONTENT Start -->(.*?)<!-- CONTENT End -->/",$s,$regs)) {
				$data['wikiContent'] = $regs[1];
			}
			// get comment
			if (preg_match_all("/<!-- COMMENT Start -->(.*?)<!-- COMMENT End -->/",$s,$regs) ) {
				$regs = $regs[1];
				if( !empty($regs) )
			      $data['wikiComment'] = $regs;
				else
				  $data['wikiComment'] = NULL;
			}
			// module page?
			if (preg_match("/<!-- MODULE Start -->(.*?)<!-- MODULE End -->/",$s,$regs)) {
				$data['wikiModule'] = $regs[1];
			}			
		}
		// default start page
		elseif ($pageID == "wiki") {
			$data['pageID'] = "wiki";
			$data['wikiMenuLabel'] = "Wiki";
			$data['wikiSuperadminPage'] = '0';				
			$data['wikiChanges'] = "";
			$data['wikiContent'] = str_STARTINSTRUCTIONS;
			$data['wikiComment'] = NULL;
			$data=$this->addSpamFields($data);
			$this->savePage($data);
		}
		// page not found
		else {
			$data['pageID'] = $pageID;
			$data['wikiMenuLabel'] = "Missing page";
			$data['wikiSuperadminPage'] = '0';				
			$data['wikiChanges'] = "";
			$data['wikiContent'] = "";
			$data['wikiComment'] = NULL;
			//echo "parent.displaySystemMessage(\"" . htmlentities(err_PAGENOTFOUND.": ".$pageID,ENT_QUOTES,"utf-8") . "\");\n";
			//echo "parent.logError(\"" . addslashes(err_PAGENOTFOUND) . "\");\n";
		}
		return $data;
	}
	
	/**
	 * Convert text to be html conform
	 *
	 * @param string $s
	 * @return string
	 */
	function txt2html($s)	{
		if (empty($s))
			return '';
		else
			return str_replace(array("\n", "\r", '"'), array("<br>", "", '&quot;'), $this->xmlentities($s));
	#		return strtr(str_replace(array("\n"), array("<br>"), $s), get_html_translation_table(HTML_ENTITIES));
	}
	
	/**
	 * Convert text to be xml conform
	 *
	 * @param string $s
	 * @return string
	 */
	function txt2xml($s)	{
		if (empty($s))
			return '';
		else
			return str_replace(array("\n", '"'), array("\n", '&quot;'), $this->xmlentities($s));
	}
	
	/**
	 * Correct xml entities
	 *
	 * @param string $s
	 * @return string
	 */
	function xmlentities($s) {
		return str_replace(array('&', '"', '<', '>'), array('&amp;' , '&quot;', '&lt;' , '&gt;'), $s);
	#	return str_replace(array('&', '"', "'", '<', '>', '?'), array('&amp;' , '&quot;', '&apos;' , '&lt;' , '&gt;', '&apos;'), $s);
	}
	
	/**
	 * Check login
	 *
	 */
	function checkLogin($loggedOut=false) {
		if (!$loggedOut && isset($_SESSION[WIKI_PREFIX.'wloginsess']) && isset($_SESSION[WIKI_PREFIX.'wloginpass'])) {
			$this->userSession();
			return session_id();
		} else {
			if (!$loggedOut AND isset($_COOKIE[WIKI_PREFIX."_uXn"]) AND isset($_COOKIE[WIKI_PREFIX."_uPw"])) {
				//$this->logout();
				return $this->validateLogin($_COOKIE[WIKI_PREFIX."_uXn"],$_COOKIE[WIKI_PREFIX."_uPw"],"1",true);
			}
			$this->setGuest();
			return false;
		}
	}
	
	/**
	 * Validate login
	 *
	 * @param string $pass
	 * @return string
	 */
	function validateLogin($username,$pass,$remember,$fromcookie=false) {
		$db=new Database();
		//my_error_handler(9999,"validatelogin",session_id(),WIKI_PREFIX);
		if (($username=="superadmin") OR ($username=="root")) {
			if ((!$fromcookie AND $pass == SUPERPASSWORD) OR ($fromcookie AND $pass==md5(SUPERPASSWORD))) {
				$_SESSION[WIKI_PREFIX.'wloginsess'] = session_id();
				$_SESSION[WIKI_PREFIX.'wloginpass'] = md5(SUPERPASSWORD);
				$_SESSION[WIKI_PREFIX.'wsuperadmin'] = 1;				
				$_SESSION[WIKI_PREFIX.'wusername']="Superadmin";
				$groupids=array();
				$db->query("groups");
				while ($row=$db->fetch_row()) {
					$groupids[]=$row['groupid'];
				}
				foreach ($groupids as $gid) {
					$db->query("pages","privileges,pageid","privileges=~".$gid);
					while ($row=$db->fetch_row()) {
						$pageid=$row['pageid'];
						$privileges=explode(":",$row['privileges']);
						foreach ($privileges as $p) {
							$tmp=explode("|",$p);
							if ($tmp[0]==$gid) {
								if (!isset($_SESSION[WIKI_PREFIX."wp_".$pageid]) || (intval($_SESSION[WIKI_PREFIX."wp_".$pageid])<intval($tmp[1]))) $_SESSION[WIKI_PREFIX."wp_".$pageid]=intval($tmp[1]);
								if ($tmp[1]&P_FILEUPLOAD) {
									if (!isset($_SESSION[WIKI_PREFIX."wp_ug_".$pageid])) $_SESSION[WIKI_PREFIX."wp_ug_".$pageid]="";
									if ($_SESSION[WIKI_PREFIX."wp_ug_".$pageid]!="") $_SESSION[WIKI_PREFIX."wp_ug_".$pageid].=",";
									$_SESSION[WIKI_PREFIX."wp_ug_".$pageid].=$gid;
								}
							}
						}
					}
				}
				if ($remember=="1") $this->saveCookie($username,$pass,$fromcookie);
				$this->userSession();
				return session_id();
			} else {
				$this->setGuest();
				return false;
			}
		} else {
			$db->query("users","","username=".$username);
			$row=$db->fetch_row();
			if ((!$fromcookie AND md5($pass)==$row['password']) OR ($fromcookie AND $pass==$row['password'])) {
				$_SESSION[WIKI_PREFIX.'wloginsess'] = session_id();
				$_SESSION[WIKI_PREFIX.'wloginpass'] = md5($pass);
				$_SESSION[WIKI_PREFIX.'wsuperadmin'] = 0;	
				$_SESSION[WIKI_PREFIX.'wuserid'] = $row['userid'];	
				$_SESSION[WIKI_PREFIX.'wusername'] = $row['username'];
				$usergroups="";
				$groups=explode(":",$row['groupids']);
				foreach ($groups as $g) {
					$db->query("groups","","groupid=$g");
					$row=$db->fetch_row();
					if ($usergroups!="") $usergroups.=",";
					$usergroups.=$row['groupname'];
				}
				$_SESSION[WIKI_PREFIX.'wusergroups'] = $usergroups;
				$groupids=$groups;
				$db->query("pages","privileges","pageid=wiki");
				$row=$db->fetch_row();
				$tmp=explode(":",$row['privileges']);
				foreach ($tmp as $t) {
					$tmp2=explode("|",$t);
					if ($tmp2[0]=="0") {
						$groupids[]=$t;
						break;
					}
				}
				foreach ($groupids as $gid) {
					$db->query("pages","privileges,pageid","privileges=~".$gid);
					while ($row=$db->fetch_row()) {
						$pageid=$row['pageid'];
						$privileges=explode(":",$row['privileges']);
						foreach ($privileges as $p) {
							$tmp=explode("|",$p);
							if ($tmp[0]==$gid) {
								if (!isset($_SESSION[WIKI_PREFIX."wp_".$pageid])) $_SESSION[WIKI_PREFIX."wp_".$pageid]=0;
								if  (intval($_SESSION[WIKI_PREFIX."wp_".$pageid])<intval($tmp[1])) $_SESSION[WIKI_PREFIX."wp_".$pageid]=intval($tmp[1]);
								if ($tmp[1]&P_FILEUPLOAD) {
									if (!isset($_SESSION[WIKI_PREFIX."wp_ug_".$pageid])) $_SESSION[WIKI_PREFIX."wp_ug_".$pageid]="";
									if ($_SESSION[WIKI_PREFIX."wp_ug_".$pageid]!="") $_SESSION[WIKI_PREFIX."wp_ug_".$pageid].=",";
									$_SESSION[WIKI_PREFIX."wp_ug_".$pageid].=$gid;
								}
							}
						}
					}
				}
				if ($remember=="1") $this->saveCookie($username,$pass,$fromcookie);
				$this->userSession();
				return session_id();
			} else {
				$this->setGuest();
				return false;
			}
		}
	}

	function saveCookie($user,$pass,$fromcookie=false) {
		if (!$fromcookie) $pass=md5($pass);
		setcookie(WIKI_PREFIX."_uXn",$user,time()+365*60*24*30,"/");
		setcookie(WIKI_PREFIX."_uPw",$pass,time()+365*60*24*30,"/");
	}

	function deleteCookie() {
		setcookie(WIKI_PREFIX."_uXn","",time()-3600,"/");
		setcookie(WIKI_PREFIX."_uPw","",time()-3600,"/");
	}

	function getHomePage() {
		$db=new Database();
		$ret="";
		if (isset($_SESSION[WIKI_PREFIX.'wuserid']) AND ($_SESSION[WIKI_PREFIX.'wuserid']!="")) {
			$db->query("users","","userid=".$_SESSION[WIKI_PREFIX.'wuserid']);
			$row=$db->fetch_row();
			$ret=$row['homepage'];
		}
		return $ret;	
	}

	function getPageIds() {
		$pageids="";	
		foreach (array_keys($_SESSION) as $key) {
			if (substr($key,0,strlen(WIKI_PREFIX."wp_"))==WIKI_PREFIX."wp_" AND substr($key,0,strlen(WIKI_PREFIX."wp_ug_"))!=WIKI_PREFIX."wp_ug_") {
				if ($pageids!="") $pageids.="|";
				$pageids.=str_replace(WIKI_PREFIX."wp_","",$key).":".$_SESSION[$key];
			}
		}
		return $pageids;	
	}
	
	function getUploadGroups() {
		$ret="";
		$db=new Database();	
		foreach (array_keys($_SESSION) as $key) {
			if (substr($key,0,strlen(WIKI_PREFIX."wp_ug_"))==WIKI_PREFIX."wp_ug_") {
				if ($ret!="") $ret.="|";
				$tmp=explode(",",$_SESSION[$key]);
				$tmpret="";
				foreach ($tmp as $t) {
					if ($t!=0) {
						if ($tmpret!="") $tmpret.=",";
						$db->query("groups","","groupid=".$t);
						$row=$db->fetch_row();
						$tmpret.=$row['groupname'];
					}
				}
				$ret.=str_replace(WIKI_PREFIX."wp_ug_","",$key).":".$tmpret;
			}
		}
		return $ret;	
	}
	
	function setGuest() {
		$db=new Database();
		$db->query("pages");
		while ($row=$db->fetch_row()) {
			$pageid=$row['pageid'];
			$privs=0;
			$pageprivs=explode(":",$row['privileges']);
			foreach ($pageprivs as $pp) {
				$tmp=explode("|",$pp);
				if ($tmp[0]=="0") {
					$privs=intval($tmp[1]);
					break;
				}
			}
			$_SESSION[WIKI_PREFIX."wp_".$pageid]=$privs;
		}
		if (!isset($_SESSION[WIKI_PREFIX.'wusergroups']))  $_SESSION[WIKI_PREFIX.'wusergroups'] = "Guest";
		$this->userSession();
	}
	
	/**
	 * Logout
	 *
	 */
	function logout() {
		//my_error_handler(9999,"logout",session_id(),WIKI_PREFIX);
		unset($_SESSION[WIKI_PREFIX.'wloginsess']);
		unset($_SESSION[WIKI_PREFIX.'wloginpass']);
		unset($_SESSION[WIKI_PREFIX.'wsuperadmin']);
		unset($_SESSION[WIKI_PREFIX.'wuserid']);	
		unset($_SESSION[WIKI_PREFIX.'wusername']);	
		unset($_SESSION[WIKI_PREFIX.'wusergroups']);
		foreach (array_keys($_SESSION) as $key) {
			if (substr($key,0,strlen(WIKI_PREFIX."wp_"))==WIKI_PREFIX."wp_") unset($_SESSION[$key]);
		}
		$this->deleteCookie();
		$this->setGuest();
		return array(str_LOGIN,"checkLogin(true)");
	}
	
	/**
	 * Get image information
	 *
	 * @param string $img
	 * @return array
	 */
	function getImageInfo($img) {
		$size = array();
		if (file_exists($img)) {
			$info = getimagesize($img);
			if (isset($info[0]) AND isset($info[1])) {
				$size['width'] = $info[0];
				$size['height'] = $info[1];
			} else {
				$size['width'] = 0;
				$size['height'] = 0;
			}
		} else {
			$size['width'] = 0;
			$size['height'] = 0;
		}
		return $size;
	}
	
	/**
	 * Log custom application error
	 *
	 * @param string $error
	 * @param string $script
	 * @param string $line
	 */
	function logAppError($error,$script,$line) {
		my_error_handler(9999,$error,$script,$line);
	}
	
	function createSitemap() {
		$sitemap="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		$sitemap.="<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\n";
		$pages=array_keys($this->tree);
		foreach ($pages as $p) {
			if ($p=="0") $p="wiki";
			if ($this->isPublic($p)) {
				$url=$this->getSEOUrl($p);
				$sitemap.="\t<url>\n";
				$sitemap.="\t\t<loc>".str_replace("/ajax","",ROOT_URL)."/".$url."</loc>\n";
				$sitemap.="\t\t<changefreq>daily</changefreq>\n";
				$sitemap.="\t\t<priority>0.6</priority>\n";
				$sitemap.="\t</url>\n";
			}
		}
		$sitemap.="</urlset>\n";
		$fp = @fopen(PRE."sitemap.xml", "w");
		if ($fp) {
			flock($fp,2);
			fputs($fp,$sitemap);
			flock($fp,3);
			fclose($fp);
		}
	}

	function SEO() {
		// make tree string and find public pages
		$treeS="<br/><br/>";
		$js="var rootUrl2='".ROOT_URL."/';\n";
		$public=array();

		foreach ($this->tree as $t) {
			$id=$t['id'];
			$text=$t['text'];
			if ($this->isPublic($id)) {
				$treeS.="<a href=\"".str_replace("index.php","",$_SERVER['PHP_SELF']).$this->getSEOUrl($id)."\">".$text."</a><br/>\n";
				$public[]=$id;
			}
			$js.="allPages['".$id."']='".$this->getSEOUrl($id)."';\n";
		}
		echo "<script type=\"text/javascript\" language=\"javascript\">\n";
		echo $js;
		echo "</script>\n";
		echo "<div id=\"hiddenTree\" style=\"display: none\">$treeS</div>\n";
		$pageID="wiki";
		if (CALLED_PAGEID!="") $pageID=CALLED_PAGEID;
		if (in_array($pageID,$public)) {
			$page=$this->wikiPage($pageID,$this->guestPrivs(),true,true);
			preg_match_all("/<script.*>.*<\\/script>/msU",$page,$scripts,PREG_SET_ORDER);
			foreach ($scripts as $script) {
				$page=str_replace($script[0],"",$page);
			}
			if (!isset($_COOKIE['GASO'])) {
				preg_match_all("/<link.*>/msU",$page,$scripts,PREG_SET_ORDER);
				foreach ($scripts as $script) {
					$page=str_replace($script[0],"",$page);
				}
				preg_match_all("/<form.*>/msU",$page,$scripts,PREG_SET_ORDER);
				foreach ($scripts as $script) {
					$page=str_replace($script[0],"",$page);
				}
				preg_match_all("/<\/form.*>/msU",$page,$scripts,PREG_SET_ORDER);
				foreach ($scripts as $script) {
					$page=str_replace($script[0],"",$page);
				}
				preg_match_all("/<.*>/msU",$page,$scripts,PREG_SET_ORDER);
				foreach ($scripts as $script) {
					$rpl=$script[0];
					$match=preg_match("/id\\s*=\\s*\".*\"/",$rpl,$res);
					if (!$match) $match=preg_match("/id\\s*=\\s*'.*'/",$rpl,$res);
					if ($match) $rpl=str_replace($res[0],"",$rpl);
					$match=preg_match("/class\\s*=\\s*\".*\"/",$rpl,$res);
					if (!$match) $match=preg_match("/class\\s*=\\s*'.*'/",$rpl,$res);
					if ($match) $rpl=str_replace($res[0],"",$rpl);
					$match=preg_match("/name\\s*=\\s*\".*\"/",$rpl,$res);
					if (!$match) $match=preg_match("/name\\s*=\\s*'.*'/",$rpl,$res);
					if ($match) $rpl=str_replace($res[0],"",$rpl);
					$page=str_replace($script[0],$rpl,$page);
				}
			}
			$page=$this->pageid2SEO($page);
			echo "<div id=\"hiddenContent\" style=\"display: none\">$page</div>\n";
		}
	}
	
	function isPublic($id,$comp="") {
		if (is_array($id)) $id=$comp;
		return $this->isUserPage($id,"",true);
	}
		
	function unserializeTree($keepassoc=false,$old=false) {
		if (!$old) return $this->unserializeTreeFromDb($keepassoc);
		$filename = PRE . $this->userfiles_menu . $this->menu_filename;
		$data = array();
		$string = "";
		if (file_exists($filename)) {
			// read file
			$file = file($filename);
			//make string
			foreach ($file as $row) {
				$string .= trim($row);
			}

			//unserialize tree
			
			$string=str_replace('<?xml version="1.0"?><tree id="0">','',$string);
			$string=str_replace("</tree>","",$string);
			// start from "wiki" node
			$tmpd=$this->loadPage("wiki");
			$data[0]['id']="wiki";
			$data[0]['parent']="0";
			$data[0]['inner']=$string;
			$data[0]['text']=isset($tmpd['wikiMenuLabel'])?$tmpd['wikiMenuLabel']:"Wiki";
			$data[0]['sa']=isset($tmpd['wikiSuperadminPage'])?$tmpd['wikiSuperadminPage']:"0";
				for ($i=0; $i<count($data); $i++) {
					$id=$data[$i]['id'];
					$tmp=$this->getSubNodes($data[$i]['inner'],$id);
					if ($tmp!==false AND is_array($tmp)) {
						foreach ($tmp as $t) {
							$data[]=$t;
						}
					}
				}
		} else {
			return false;
		}
		return $data;
	}

	function getSubNodes($string,$id) {
		$ret=array();
		$start=strpos($string,"<userdata");
		if ($start===false) return "false";
		$left=substr($string,0,$start);
		$string=substr($string,$start);
		$countL=substr_count($left,"<item");
		$countL=$countL-substr_count($left,"</item>");
		for ($i=0; $i<$countL; $i++) {
			$pos=strrpos($string,"</item>");
			$string=substr($string,0,$pos);
		}
		$start=0;
		$countS=0;
		$pos=0;
		while (true) {
			$posOpen=strpos($string,"<item",$pos);
			$posClose=strpos($string,"</item>",$pos);
			if (($posOpen!==false) AND ($posClose!==false) AND ($posOpen<$posClose)) {
				$countS++;
				$pos=$posOpen+5;
			} else {
				break;
			}
		}
		if ($countS==0) return false;
		$countTmp=0;
		$firstpos=$pos;
		while ($countTmp!=$countS) {
			$posClose=strpos($string,"</item>",$pos+1);
			$posOpen=strpos($string,"<item",$pos+1);
			if (($posOpen!==false) AND ($posOpen>$posClose)) {
				$countS++;
				$start=strpos($string,">")+1;
				$start1=strpos($string,"<item",$start)+5;
				$start=strpos($string,">",$start1)+1;
				$count=count($ret);
				$ret[$count]['parent']=$id;
				$ret[$count]['inner']=substr($string,$start);
				$tmp=$ret[$count]['inner'];
				$tmppos=0;
				while (substr_count($tmp,"<item")!=substr_count($tmp,"</item>")) {
					$tmppos=strpos($ret[$count]['inner'],"</item>",$tmppos+1);
					if ($tmppos!==false) {
						$tmp=substr($ret[$count]['inner'],0,$tmppos);
					} else {
						break;
					}
				}
				$ret[$count]['inner']=$tmp;
				$currNode=substr($string,$start1-5,$tmppos-$start1+5+$start);
				$ret[$count]['id']=substr($string,$start1,$start-$start1);
				$tmpPos=strpos($ret[$count]['inner'],"<userdata");
				$tmpS=substr($ret[$count]['inner'],$tmpPos);
				$tmpPos=strpos($ret[$count]['inner'],">")+1;
				$tmpPos2=strpos($ret[$count]['inner'],"<",$tmpPos);
				$ret[$count]['sa']=substr($ret[$count]['inner'],$tmpPos,$tmpPos2-$tmpPos);
				preg_match("/\\stext=\"([^\"]*)\"\\s/",$ret[$count]['id'],$tmp);
				$ret[$count]['text']=$tmp[1];
				preg_match("/\\sid=\"([^\"]*)\"\\s/",$ret[$count]['id'],$tmp);
				$ret[$count]['id']=$tmp[1];
				if ($ret[$count]['inner']===false) {
					unset($ret[$count]);
				} 
				$string=substr($string,$tmppos+$start+1);
				$start=0;
				$countS=0;
				$pos=0;
				while (true) {
					$posOpen=strpos($string,"<item",$pos);
					$posClose=strpos($string,"</item>",$pos);
					if (($posOpen!==false) AND ($posClose!==false) AND ($posOpen<$posClose)) {
						$countS++;
						$pos=$posOpen+5;
					} else {
						break;
					}
				}
				$countTmp=0;
				$firstpos=$pos;
				if (!$countS) break;
			} else {
				$countTmp++;
				$pos=$posClose;
			}
		}
		$start=$firstpos;
				$start=strpos($string,">")+1;
				$start1=strpos($string,"<item",$start)+5;
				$start=strpos($string,">",$start1)+1;
				$count=count($ret);
				$ret[$count]['parent']=$id;
				$ret[$count]['inner']=substr($string,$start);
				$tmp=$ret[$count]['inner'];
				$tmppos=0;
				while (substr_count($tmp,"<item")!=substr_count($tmp,"</item>")) {
					$tmppos=strpos($ret[$count]['inner'],"</item>",$tmppos+1);
					if ($tmppos!==false) {
						$tmp=substr($ret[$count]['inner'],0,$tmppos);
					} else {
						break;
					}
				}
				$ret[$count]['inner']=$tmp;
				$currNode=substr($string,$start1-5,$tmppos-$start1+5+$start);
				$ret[$count]['id']=substr($string,$start1,$start-$start1);
				$tmpPos=strpos($ret[$count]['inner'],"<userdata");
				$tmpS=substr($ret[$count]['inner'],$tmpPos);
				$tmpPos=strpos($ret[$count]['inner'],">");
				if ($tmpPos!==false) {
					$tmpPos++;
					$tmpPos2=strpos($ret[$count]['inner'],"<",$tmpPos);
					$ret[$count]['sa']=substr($ret[$count]['inner'],$tmpPos,$tmpPos2-$tmpPos);
				} else {
					$ret[$count]['sa']=0;
				}
				if (preg_match("/\\stext=\"([^\"]*)\"\\s/",$ret[$count]['id'],$tmp)) {
					$ret[$count]['text']=$tmp[1];
				} else {
					$ret[$count]['text']="";
				}
				if (preg_match("/\\sid=\"([^\"]*)\"\\s/",$ret[$count]['id'],$tmp)) {
					$ret[$count]['id']=$tmp[1];
				} else {
					$ret[$count]['id']="";
				}
				if ($ret[$count]['inner']===false) {
					unset($ret[$count]);
				} 
		return $ret;
	}
	
	function guestPrivs() {
		$db=new Database();
		$db->query("pages","privileges","pageid=wiki");
		$row=$db->fetch_row();
		$tmp=explode(":",$row['privileges']);
		foreach ($tmp as $tmp1) {
			$tmp2=explode("|",$tmp1);
			if ($tmp2[0]=="0") {
				$ret=intval($tmp2[1]);
				break;
			}
		} 
		return $ret;
	}
	
	//show is some page viewable by user ($email="loggedUser" to check logged user perms)
	function isUserPage($id,$email,$includePublic=false,$checkAgainst=P_READ,$compCA=P_READ) {
		if (is_array($id)) {
			$id=$email;
			$email=$includePublic;
			$checkAgainst=$compCA;
		}
		if (!isset($this->tree[$id])) return false;
		//if (trim($email)=="") return false;
		$db=new Database();
		if ($email=="loggedUser") $email=strval($this->loggedUserId());
		if ($email!="") {
			if (strpos($email,"@")!==false) {
				$db->query("users","groupids","email=$email");
			} else {
				if ($email=="sa") return true;
				$db->query("users","groupids","userid=$email");
			}
			$row=$db->fetch_row();
			$groups=explode(":",$row['groupids']);
		} else {
			$groups=array();
		}
		if (!$includePublic) {
			for ($i=0; $i<count($groups); $i++) {
				if ($groups[$i]==0) unset($groups[$i]);
			}
			if (count($groups)==0) return false;
		} else {
			if (!in_array("0",$groups)) $groups[]="0";
		}
		$parent=array();
		$sa=array();
		$isUserPage=false;
		$p=$id;
		while (isset($this->tree[$p])) {
			if ($this->getUserData("sa",$this->tree[$p]['userdata'])=="1") return false;
			$db->query("pages","privileges","pageid=$p");
			$row=$db->fetch_row();
			if (($db->num_rows()==0) OR ($row['privileges']=="")) {
				if (!isset($this->tree[$p]['parent']) || $this->tree[$p]['parent']=="0") break;
				$p=$this->tree[$p]['parent'];
			} else {
				$privileges=explode(":",$row['privileges']);
				foreach ($privileges as $priv) {
					$priv2=explode("|",$priv);
					if (in_array($priv2[0],$groups) AND ((intval($priv2[1])&$checkAgainst)!=0)){
						$isUserPage=true;
					}
				}
				break;
			}
		}

		return $isUserPage;
	}
	
	//return groups that can upload files (for logged in user)
	function getULGroups($id) {
		if (!isset($this->tree[$id])) return "";
		$groups=$this->getUploadGroups();
		if ($groups=="") return "";
		$groups=explode("|",$groups);
		$ugroups=array();
		foreach ($groups as $g) {
			$tmp=explode(":",$g);
			$ugroups[$tmp[0]]=$tmp[1];
		}
		$parent=array();
		foreach ($this->tree as $t) {
			$parent[$t['id']]=$t['parent'];
		}
		$p=$id;
		$ret="";
		while (!isset($ugroups[$p])) {
			if ($p=="wiki" OR $p=="0" OR !isset($parent[$p])) break;
			$p=$parent[$p];
		}
		if (isset($ugroups[$p])) $ret=$ugroups[$p];
		if (isset($_SESSION[WIKI_PREFIX.'wsuperadmin']) AND $_SESSION[WIKI_PREFIX.'wsuperadmin']==1) {
			if ($ret=="") {
				$ret="superadmin";
			} else {			
				$ret="superadmin,".$ret;
			}
		}
		return $ret;
	}
	
	function uploadSelect($pageID) {
		$groups=$this->getULGroups($pageID);
		$s=str_FOLDER."&nbsp;";
		$s.="<select name=\"group\" id=\"group\">";
		$s.="<option value=\"\">-----</option>";
		if ($groups!="") {
			$groups=explode(",",$groups);
			foreach ($groups as $group) {
				$s.="<option value=\"".$group."/\">$group</option>";
			}
		}
		$s.="</select>";
		return $s;
	}
	
	function getModules() {
		// get all modules
		$ret=array();
		// get modules dirs
		if ($handle = @opendir(PRE . $this->modules_dir)) {
	   	 	while (false !== ($file = readdir($handle))) {
		   	    if ($file != "." && $file != ".." && is_dir(PRE . $this->modules_dir.$file)) {
		   	    	// show only compatible modules with current Wiki version
					if ($this->moduleCompatible($file)) $ret[]=$file;
		        }
		    }
		    closedir($handle);
		}
		// create databases for modules if needed
		foreach ($ret as $dir) {
			$this->createModuleDB($dir);
		}
		return $ret;
	}
	
	function moduleCompatible($mod) {
		$ret=false;
		$version=explode(".",str_replace("v","",getVersionNumber(PRE."changelog.txt")));
		$filename=PRE . $this->modules_dir.$mod."/changelog.txt";
		if (file_exists($filename)) {
			$file=file($filename);
			foreach ($file as $line) {
				$match=preg_match("/^.*COMPATIBILITY:\\s*(.*)$/",$line,$modver);
				if ($match==1) {
					$modver=explode(".",$modver[1]);
					for ($i=0; $i<5; $i++) { 
						if (!isset($modver[$i])) $modver[$i]=0;
					}
					if ((intval($modver[0])<intval($version[0])) OR ((intval($modver[0])==intval($version[0])) AND (intval($modver[1])<intval($version[1]))) OR (((intval($modver[0])==intval($version[0])) AND (intval($modver[1])==intval($version[1]))) AND (intval($modver[2])<=intval($version[2])))) $ret=true;
					break;
				}
			}
		}
		return $ret;
	}
	
	function createModuleDB($mod,$pageID="") {
		$filename=PRE . $this->modules_dir.$mod."/dbstruct.inc.php";
		if (file_exists($filename)) {
			$db=new Database();
			$dbstruct=file($filename);
			// dbstruct consists of lines of database definitions in format: dbname=field1,field2,field3...
			foreach ($dbstruct as $struct) {
				$struct=str_replace(chr(10),"",str_replace(chr(13),"",$struct));
				$tmp=explode("=",$struct);
				if ($pageID=="") {
					if (strpos($tmp[0],'{pageID}')===false) $db->create($tmp[0],$tmp[1]);
				} else {
					$db->create(str_replace('{pageID}',$pageID,$tmp[0]),$tmp[1]);
				}
			}
		}
	}
	
	function moduleName($mod) {
		$langfile=PRE . $this->modules_dir.$mod."/lang/".LANGUAGE.".inc.php";
		if (!file_exists($langfile)) $langfile=PRE . $this->modules_dir.$mod."/lang/english.inc.php";
		include($langfile);
		return $modname;
	}
	
	function loadModule($mod,$pageID) {
		$this->createModuleDB($mod,$pageID);
		$modRoot=ROOT_URL."/modules/$mod/";
		$modRoot=str_replace("ajax/","",$modRoot);
		$modUpload=PRE.$this->userfiles_uploads."modules/".$mod."/".$pageID;
		$_SESSION['modroot']=$modRoot;
		$_SESSION['mod']=$mod;
		$_SESSION['modupload']=$modUpload;
		$_SESSION['modpageID']=$pageID;
		if (IS_MOBILE AND file_exists(PRE . $this->modules_dir.$mod."/mobile.php")) {
			$file=PRE . $this->modules_dir.$mod."/mobile.php";
		} else {
			$file=PRE . $this->modules_dir.$mod."/index.php";
		}
		ob_start();
		require($file);
		$ret = str_replace("MODULE",$mod,ob_get_contents());
		ob_end_clean();
		return $ret;
	}

	function loadModuleAdmin($mod,$pageID) {
		$modRoot=ROOT_URL."/modules/$mod/";
		$modRoot=str_replace("ajax/","",$modRoot);
		$modUpload=PRE.$this->userfiles_uploads."modules/".$mod."/".$pageID;
		$_SESSION['modroot']=$modRoot;
		$_SESSION['mod']=$mod;
		$_SESSION['modupload']=$modUpload;
		$_SESSION['modpageID']=$pageID;
		$file=PRE . $this->modules_dir.$mod."/admin.php";
		ob_start();
		require($file);
		$ret = str_replace("MODULE",$mod,ob_get_contents());
		ob_end_clean();
		return $ret;
	}
	
	function putContent($s,$json,$parent=false,$noscripts=false) {
		$p="";
		if ($parent) $p="parent.";
		$scriptsPart="";
		$scriptsSrcPart="";
		$scriptsSrcPartIE="";
		$scriptCount=1;
		if (!$noscripts) {
			preg_match_all("/<script.*>(.*)<\\/script>/msU",$s,$scripts,PREG_SET_ORDER);
			foreach ($scripts as $script) {
				$match=preg_match("/<script.*\\ssrc=\"([^\"]+)\"/",$script[0],$src);
				if ($match) {
					if (strpos($src[1],"http://")===false AND strpos($src[1],"https://")===false) $src[1]=((strpos($s,"<div style=\"display: none\">###THIS IS WIKI MODULE PAGE###</div>")===false)?str_replace(basename($_SERVER['PHP_SELF']),"../",$_SERVER['PHP_SELF']):$_SESSION['modroot']).$src[1];
					$scriptsSrcPart.="if (!".$p."scriptInMemory('".$src[1]."')){\n";
						$scriptsSrcPart.=$p."IEhead[scriptAllCount]=document.createElement(\"script\");\n";
						$scriptsSrcPart.=$p."IEhead[scriptAllCount].type=\"text/javascript\";\n";
						$scriptsSrcPart.=$p."IEhead[scriptAllCount].src=\"".$src[1]."\";\n";
						$scriptsSrcPart.="if (!ie) ".$p."IEhead[scriptAllCount].onload=scriptLoaded;\n";
						//$scriptsSrcPart.=$p."headID.appendChild(".$p."IEhead[scriptAllCount]);\n";
						$scriptsSrcPart.=$p."scriptSrcs[scriptSrcs.length]='".$src[1]."';\n";
						$scriptsSrcPart.="scriptAllCount++;\n";
					$scriptsSrcPart.="}\n";
				}
				$s=str_replace($script[0],"",$s);
				$scriptsPart.=$script[1].";\n";
			}
		}
		echo "var headTags = ".$p."document.getElementsByTagName(\"head\");\n";
		echo "var headID = headTags[0];\n";
		echo $p."IEhead.length=0;\n";
		echo $p."pageLoadProgress=true;\n";
		echo $p."document.getElementById('stylesTestDiv').innerHTML='';";
		echo $p."stylesLoadProgress=false;\n";
		$matchCSS=preg_match_all("/<link\\s([^><]*)>/",$s,$styles,PREG_SET_ORDER);
		if ($matchCSS) {
			echo $p."stylesLoadProgress=true;\n";
			$stylesCount=0;
			for ($i=0; $i<count($styles); $i++) {
				if ((strpos($styles[$i][0],"stylesheet")!==false) AND (strpos($styles[$i][0],"css")!==false)) {
					$match=preg_match("/\\shref=\"([^\"]+)\"/",$styles[$i][0],$src);
					if ($match AND strpos($src[1],"/getcss.php?id=")===false) {
						echo $p."dynCSS[".$stylesCount."]=document.createElement(\"link\");\n";
						echo $p."dynCSS[".$stylesCount."].type=\"text/css\";\n";
						echo $p."dynCSS[".$stylesCount."].href=\"".str_replace("/ajax","",ROOT_URL)."/getcss.php?id=".$stylesCount."&amp;url=".rawurlencode($src[1])."\";\n";
						echo $p."dynCSS[".$stylesCount."].media=\"screen\";\n";
						echo $p."dynCSS[".$stylesCount."].id=\"inStyle".$stylesCount."\";\n";
						echo $p."document.getElementById('stylesTestDiv').innerHTML+=" . $json->encode("<div id=\"styleTest".$stylesCount."\"></div>") . ";\n";
						$newstyle=str_replace($src[1],str_replace("/ajax","",ROOT_URL)."/getcss.php?id=".$stylesCount."&url=".rawurlencode($src[1]),$styles[$i][0]);
						$s=str_replace($styles[$i][0],$newstyle,$s);
						$styles[$i][0]=$newstyle;
						$stylesCount++;
					}
				}
				$tmpS=explode($styles[$i][0],$s);
				$formStarts=preg_match("/<\\s*form\\s([^><]*)>/",strtolower($tmpS[0]));
				$formEnds=preg_match("/<\\/form\\s*>/",strtolower($tmpS[0]));
				if (($formStarts===false) OR ($formStarts==$formEnds)) $s=str_replace($styles[$i][0],"<form>".$styles[$i][0]."</form>",$s);
			}
		}
		if ($scriptsPart!="") {
			echo $p."scriptAllCount = 1;\n";
			echo $p."scriptCount = 0;\n";
		}
		if (strpos($s,"<div style=\"display: none\">###THIS IS WIKI MODULE PAGE###</div>")!==false) {
			$s=str_replace("<div style=\"display: none\">###THIS IS WIKI MODULE PAGE###</div>","",$s);
			echo $p."moduleOpen=true;\n";
			echo $p."working(true);\n";
		} else {
			echo $p."moduleOpen=false;\n";
		}
		if ($scriptsPart!="") {
			$scriptsPart=str_replace("&gt;",">",str_replace("&lt;","<",$scriptsPart));
			$scriptsPart=str_replace("document.write","alert",$scriptsPart);
			$scriptsPart=str_replace("document.getElementById","newGetElementById",$scriptsPart);
			$scriptsPartTMP=explode_js($scriptsPart);
			$scriptsPart="";
			$onlyScriptsPart="";
			for ($i=0; $i<count($scriptsPartTMP); $i++) {
				//$scriptsPartTMP[$i]=preg_replace("/([\\s\\t])*(\\b[^\\s=]*setTimeout)/","\\1".$p."toutIDs[".$p."toutIDs.length]=\\2",$scriptsPartTMP[$i]);
				//$scriptsPartTMP[$i]=preg_replace("/([\\s\\t])*(\\b[^\\s=]*setInterval)/","\\1".$p."intIDs[".$p."toutIDs.length]=\\2",$scriptsPartTMP[$i]);
				$scriptsPart.="iDebugLine=$i;\n".$scriptsPartTMP[$i].";\n";
				$onlyScriptsPart.=$i.": ".$scriptsPartTMP[$i].";\n";
			}
			echo $p."headSrcDebug=".$json->encode($onlyScriptsPart).";\n;";
			$scriptsPart="executingInner=true;\n".$scriptsPart."executingInner=false;\niDebugLine=\"none\";\n";
			echo $p."IEhead[0]=document.createElement(\"script\");\n;";
			echo $p."IEhead[0].type=\"text/javascript\";\n;";
			echo $p."IEhead[0].id=\"script000\";\n;";
			echo $p."IEhead[0].text=".$json->encode($scriptsPart).";\n;";
			echo $scriptsSrcPart;
			echo "if (".$p."ie) ieLoadHeadScripts();\n";	
			echo "if (!".$p."ie) ".$p."scriptLoaded();\n";	
		}
		echo $p."document.getElementById('content').innerHTML=" . $json->encode($s) . ";\n";
		echo $p."addDynStyles();\n";
	}
	
	function user($userid) {
		if ($userid=="sa") return "Superadmin";
		if ($userid=="") return "Guest";
		$db=new Database();
		$db->query("users","username","userid=$userid");
		$row=$db->fetch_row();
		return $row['username'];
	}
	
	function loggedUserId() {
		if (isset($_SESSION[WIKI_PREFIX.'wsuperadmin']) && $_SESSION[WIKI_PREFIX.'wsuperadmin'] == 1) return "sa";	
		return (isset($_SESSION[WIKI_PREFIX.'wuserid'])?$_SESSION[WIKI_PREFIX.'wuserid']:"");	
	}
	
	function getSEOUrl($pageID,$withget=true) {
		$url=$pageID;
		$db=new Database();
		$db->query("urls","","pageid=".$pageID);
		if ($db->num_rows()>0) {
			$row=$db->fetch_row();
			if (!isset($row['url'])) return "";
			if (trim($row['url'])!="" OR !$withget) $url=trim($row['url']);
		} else if (!$withget) {
			return "";
		}
		if ($url=="wiki") $url="";
		if ($withget) $url=GET_URL.$url;
		return $url;
	}

	function SEOUrlExists($url,$pageID=-2) {
		$ret=false;
		$db=new Database();
		$db->query("urls","","url=".$url);
		if ($db->num_rows()>0) {
			$row=$db->fetch_row();
			if ($row['pageid']!=$pageID) $ret=true;
		}
		return $ret;
	}

	function getPageIDFromUrl($url) {
		if ($url=="") return "wiki";
		$ret=false;
		$db=new Database();
		$db->query("urls","","url=".$url);
		if ($db->num_rows()>0) {
			$row=$db->fetch_row();
			$ret=$row['pageid'];
		} else {
			if (in_array($url,array_keys($this->tree))) $ret=$url;
		}
		return $ret;
	}

	function pageTitle($pageID="",$sitetitle="###") {
		$title="";
		if ($pageID=="") $pageID=CALLED_PAGEID;
		if ($pageID=="") $pageID="wiki";
		if ($sitetitle=="###") $sitetitle=SITETITLE;
		if ($pageID!="") {
			if ($sitetitle==SITETITLE) $title=(isset($this->tree[$pageID])?$this->tree[$pageID]['text']:"");
			$db=new Database();
			$db->query("titles","","pageid=".$pageID);
			if ($db->num_rows()>0) {
				$row=$db->fetch_row();
				if (trim($row['title'])!="") {
					$title=trim($row['title']);
					$sitetitle="";
				}
			}
		}
		return $sitetitle. (($sitetitle!="")?" - ":"") . $title;
	}

	function keywords($pageID) {
		$ret="";
		$db=new Database();
		$db->query("keywords","","pageid=".$pageID);
		if ($db->num_rows()>0) {
			$row=$db->fetch_row();
			$ret=trim($row['key']);
		}
		return $ret;	
	}
	
	function description($pageID) {
		$ret="";
		$db=new Database();
		$db->query("descriptions","","pageid=".$pageID);
		if ($db->num_rows()>0) {
			$row=$db->fetch_row();
			$ret=trim($row['desc']);
		}
		return $ret;	
	}
	
	function SEOForm($pageID) {
		$s="";
		$s.="<div id=\"seoFormDiv\" style=\"border: 1px solid black; width: ".VEDITORW."\">";
		$s.="<table cellpadding=\"10\" cellspacing=\"0\" border=\"0\">";
		$s.="<tr><td>&nbsp;".str_PAGE_URL.":</td><td width=\"100%\"><input type=\"text\" style=\"width: 100%\" id=\"pageURL\" name=\"pageURL\" value=\"".$this->getSEOUrl($pageID,false)."\" onfocus=\"this.select()\"/><div id=\"pageURLExists\" style=\"display: none; color: red; font-weight: bold;\">".str_URL_EXISTS."</div></td></tr>";
		$s.="<tr><td>&nbsp;".str_META_TITLE."</td><td width=\"100%\"><input type=\"text\" style=\"width: 100%\" name=\"pageTitle\" value=\"".$this->pageTitle($pageID,"")."\" /></td></tr>";
		$s.="<tr><td>&nbsp;".str_META_KEYWORDS."</td><td width=\"100%\"><input type=\"text\" style=\"width: 100%\" name=\"pageKeywords\" value=\"".$this->keywords($pageID)."\" /></td></tr>";
		$s.="<tr><td>&nbsp;".str_META_DESCRIPTION.":</td><td width=\"100%\"><textarea rows=\"2\" cols=\"50\" style=\"width: 100%\" name=\"pageDescription\">".htmlentities($this->description($pageID),ENT_NOQUOTES,"UTF-8")."</textarea></td></tr>";
		$s.="</table></div>";
		$s.="<input type=\"hidden\" name=\"pID\" id=\"pID\" value=\"".$pageID."\" />";
		return $s;
	}
	
	function saveSEOData($data) {
		$pageID=$data['pageID'];
		$db=new Database();
		if (isset($_POST['pageURL']) AND (!$this->SEOUrlExists($_POST['pageURL'],$pageID) OR $_POST['pageURL']=="")) {
			$dbdata=array();
			$dbdata['pageid']=$pageID;
			$dbdata['url']=stripslashes($_POST['pageURL']);
			if (substr($dbdata['url'],0,strlen("http:"))=="http:") $dbdata['url']=substr($dbdata['url'],strlen("http:"));
			if (substr($dbdata['url'],0,strlen("https:"))=="https:") $dbdata['url']=substr($dbdata['url'],strlen("https:"));
			while (substr($dbdata['url'],0,1)=="/") {
				$dbdata['url']=substr($dbdata['url'],1);
			}
			$dbdata['url']=str_replace(array("."," ","&","/","'",'"',"?"),array("-","-","-and-","","",'',""),$dbdata['url']);
			$db->query("urls","","pageid=$pageID");
			if ($db->num_rows()==0) {
				$db->add_row("urls", $db->makeQuery($dbdata));
			} else {
				$db->update("urls", $db->makeQuery($dbdata),"pageid=$pageID");
			}
		}
		if (isset($_POST['pageKeywords'])) {
			$dbdata=array();
			$dbdata['pageid']=$pageID;
			$dbdata['key']=stripslashes($_POST['pageKeywords']);
			$db->query("keywords","","pageid=$pageID");
			if ($db->num_rows()==0) {
				$db->add_row("keywords", $db->makeQuery($dbdata));
			} else {
				$db->update("keywords", $db->makeQuery($dbdata),"pageid=$pageID");
			}
		}
		if (isset($_POST['pageDescription'])) {
			$dbdata=array();
			$dbdata['pageid']=$pageID;
			$dbdata['desc']=stripslashes($_POST['pageDescription']);
			$db->query("descriptions","","pageid=$pageID");
			if ($db->num_rows()==0) {
				$db->add_row("descriptions", $db->makeQuery($dbdata));
			} else {
				$db->update("descriptions", $db->makeQuery($dbdata),"pageid=$pageID");
			}
		}
		if (isset($_POST['pageTitle'])) {
			$dbdata=array();
			$dbdata['pageid']=$pageID;
			$dbdata['title']=htmlspecialchars(stripslashes($_POST['pageTitle']),ENT_QUOTES,"UTF-8");
			$db->query("titles","","pageid=$pageID");
			if ($db->num_rows()==0) {
				$db->add_row("titles", $db->makeQuery($dbdata));
			} else {
				$db->update("titles", $db->makeQuery($dbdata),"pageid=$pageID");
			}
		}
	}

	function createModuleFolder($mod,$pageID) {
		if (!file_exists(PRE.$this->userfiles_uploads."modules")) @mkdir(PRE.$this->userfiles_uploads."modules");
		if (!file_exists(PRE.$this->userfiles_uploads."modules/".$mod)) @mkdir(PRE.$this->userfiles_uploads."modules/".$mod);
		if (!file_exists(PRE.$this->userfiles_uploads."modules/".$mod."/".$pageID)) @mkdir(PRE.$this->userfiles_uploads."modules/".$mod."/".$pageID);
	}
	
	function deleteModulePage($pageID) {
		$data = $this->loadPage($pageID);
		// is module page?
		if (isset($data['wikiModule'])) {
			$mod=trim($data['wikiModule']);
			if ($mod!="") {
				$filename=PRE . $this->modules_dir.$mod."/dbstruct.inc.php";
				if (file_exists($filename)) {
					$db=new Database();
					$dbstruct=file($filename);
					// dbstruct consists of lines of database definitions in format: dbname=field1,field2,field3...
					foreach ($dbstruct as $struct) {
						$struct=str_replace(chr(10),"",str_replace(chr(13),"",$struct));
						$tmp=explode("=",$struct);
						if (strpos($tmp[0],'{pageID}')===false) {
							$db->delete($tmp[0],"pageid=".$pageID);
						} else {
							$db->drop(str_replace('{pageID}',$pageID,$tmp[0]));
						}
					}
				}
				$dir=PRE.$this->userfiles_uploads."modules/".$mod."/".$pageID;
				if (file_exists($dir)) {
					if ($handle = @opendir($dir)) {
				   	 	while (false !== ($file = readdir($handle))) {
					   	    if (!is_dir($dir."/".$file)) @unlink($dir."/".$file);
					    }
					    closedir($handle);
					}
					@rmdir($dir);
				}
			}
		}
	}
	
	function pageid2AJAX($s) {
		if (IS_MOBILE) return $this->pageid2SEO($s);
		$match=preg_match_all("/<a\\s*.*href=['|\"](.*)['|\"].*>/msU",$s,$hrefs,PREG_SET_ORDER);
		if ($match) {
			foreach ($hrefs as $href) {
				$a=$href[0];
				$link=$href[1];
				if (substr($link,0,strlen(ROOT_URL))==ROOT_URL || substr($link,0,strlen("http"))!="http") {
					$match2=preg_match("/page=(.+)/",$link,$pid);
					if ($match2) {
						$pageid=$pid[1];
						$rpl=str_replace($link,"#",$a);
						$match3=preg_match("/onclick=(['|\"])(.*)['|\"]/msU",$rpl,$click);
						if (!$match3) {
							$rpl=str_replace(">"," onclick=\"openItem('".$pageid."')\">",$rpl);
						} else {
							$rpl2=str_replace("onclick=".$click[1],"onclick=".$click[1]."openItem('".$pageid."');",$click[0]);
							$rpl=str_replace($click[0],$rpl2,$rpl);
						}
						$s=str_replace($a,$rpl,$s);
					}
				}
			}
		}
		return $s;
	}
	
	function SEO2Pageid($s) {
		$match=preg_match_all("/<a\\s*.*href=['|\"](.*)['|\"].*>/msU",$s,$hrefs,PREG_SET_ORDER);
		if ($match) {
			foreach ($hrefs as $href) {
				$a=$href[0];
				$link=$href[1];
				if (substr($link,0,strlen(ROOT_URL))==ROOT_URL || substr($link,0,strlen("http"))!="http") {
					$pageid=$this->getPageIDFromUrl(str_replace(ROOT_URL,"",$link));
					if ($pageid!==false) {
						$rpl=str_replace($link,"index.php?page=".$pageid,$a);
						$s=str_replace($a,$rpl,$s);
					}
				}
			}
		}
		return $s;	
	}

	function fixSEOcontent() {
		if (!isset($_POST['confirmFix'])) {
			$page="<form method='post' action='".$_SERVER['PHP_SELF']."'>
						<b>Proceeding with SEO fix can permanently damage your pages!</b><br /><br />
						Please backup ALL you pages before proceeding:<br />
						Copy content of <b><i>".$this->userfiles_pages."</i></b> folder from your server to your computer to back up data!<br />
						If something goes wrong, just copy backed up data to <b><i>".$this->userfiles_pages."</i></b> folder on your server and overwrite all files with original data. <br /><br />
						<b>If you don't back up your data telepark takes no responsibility if you damage content of your pages!</b><br /><br /><br /><br />
						<input type='submit' name='confirmFix' value='Proceed' class='wikiButton' style='color: red' />
						</form>";
		} else {
			$folder=PRE . $this->userfiles_pages;
			if ($handle = @opendir($folder)) {
		   	 	while (false !== ($file = readdir($handle))) {
			   	    if ($file != "." && $file != ".." && strtolower(substr($file,strlen($file)-5)) == ".wiki") {
			            $content = $this->loadPage(str_replace(".wiki","",$file));
			            echo "Fixing: ".$content['wikiMenuLabel']."<br/>";
			            $content['wikiContent']=$this->SEO2Pageid($content['wikiContent']);
			            $content['pageID']=str_replace(".wiki","",$file);
			            $this->savePage($content,'',true);
			        }
			    }
			    closedir($handle);
			}
		
		}
		echo "<noscript>".str_NOSCRIPT."</noscript>\n";
		echo '<script type="text/javascript" language="javascript">
					openPageAtStart=false;
				</script>';
		//echo "<div id=\"content\" style=\"display: none;\"></div>";
		echo "<div id=\"content\" style=\"width: " . CONTENT_WIDTH . ";\">".$page."</div>";
	}
	
	function pageid2SEO($s) {
		$match=preg_match_all("/<a\\s*.*href=['|\"](.*)['|\"].*>/msU",$s,$hrefs,PREG_SET_ORDER);
		if ($match) {
			foreach ($hrefs as $href) {
				$a=$href[0];
				$link=$href[1];
				if (substr($link,0,strlen(ROOT_URL))==ROOT_URL || substr($link,0,strlen("http"))!="http") {
					$match2=preg_match("/telepark\\.wiki=(.+)/",$link,$pid);
					if ($match2) {
						$pageid=$pid[1];
						$rpl=str_replace($link,$this->getSEOUrl($pageid),$a);
						$s=str_replace($a,$rpl,$s);
					}
				}
			}
		}
		return $s;	
	}

	// data processor
	function processorError($error,$parentid) {
		$s="<data><action type='error'>ERROR: ";
		$s.=$error."|".$parentid;
		$s.="</action></data>";
		return $s;
	}
	
	function processorResponse($action,$inid,$outid,$parentid,$debug="") {
		$s="<data><action type=\"".$action."\" sid=\"".$inid."\" tid=\"".$outid."\"/>";
		$s.="<action type='refresh'>".$parentid."</action>";
		if ($debug!="") $s.="<action type='debug'>".$debug."</action>";
		$s.="</data>";
		return $s;
	}

	function setUserDataFromPost($userdata) {
		$udata=array();
		$ud=array();
		foreach ($userdata as $key=>$val) {
			$udata[]=$key.":".$val;
			$ud[]=$key;
		}
		foreach ($this->usersdata as $u=>$default) {
			if (!in_array($u,$ud)) {
				$ud[]=$u;
				$udata[]=$u.":".$default;
			}
		}
		$userdata=implode(",",$udata);
		return $userdata;	
	}
	
	function isEditing($id) {
		$ret=false;
		$db=new Database();
		$db->query("sessions","","sessionid!=".session_id());
		if ($db->num_rows()>0) {
			while ($row=$db->fetch_row()) {
				$ids=explode(",",$row['refreshids']);
				if (in_array($id,$ids)) {
					$ret=true;
					break;
				}
			}
		}
		return $ret;
	}
	
	function updateInTree($id,$parentid,$order,$text,$userdata) {
		if (strpos($id,"fake_load_xml")!==false) return $this->processorResponse("update",$id,$id,"");
		if ($id==$parentid) return $this->processorError("Data update error: can't be parent to itself!","wiki");
		if (in_array($parentid,explode(",",$this->tree[$id]['children']))) {
			$this->addIdToRefresh($id.",".$parentid);		
			return $this->processorError("Item already moved by another user!","fake_stop_drop");
		}
		$db=new Database();
		$db->query("tree","","id=".$id);
		if ($db->num_rows()==0) return $this->processorError("Data with pageid: ".$id." (".$text.") doesn't exist!",$parentid);
		if (!$this->isUserPage($id,"loggedUser",true,P_EDIT) || ($parentid!="0" && !$this->isUserPage($parentid,"loggedUser",true,P_EDIT))) return $this->processorError("UPDT:Access denied parent:".$parentid.", id: ".$id."!",$parentid);
		$olddata=$db->fetch_row();
		$data=array();
		$data['parent']=$parentid;
		$data['order']=$order;
		$data['text']=$text;
		$data['userdata']=$this->setUserDataFromPost($userdata);
		if ($db->update("tree", $db->makeQuery($data),"id=".$id)) {
			// moved to another node
			$toRefresh=$parentid;
			if ($olddata['parent']!=$parentid || $olddata['order']!=$order) {
				$this->fixTreeOrder($parentid,$order,$id);
				if ($olddata['parent']!=$parentid) {
					$this->fixTreeOrder($olddata['parent']);
					$toRefresh.=",".$olddata['parent'];
				}
			}
			$this->addIdToRefresh($toRefresh);
			$this->createSitemap();
			return $this->processorResponse("update",$id,$id,"");
		} else {
			$this->processorError("Data write error: ".$db->db_error,$parentid);
		}
	}

	function insertInTree($id,$parentid,$order,$text,$userdata,$new=true) {
		if (strpos($id,"fake_load_xml")!==false) return $this->processorResponse("insert",$id,$id,"");
		if ($id==$parentid) return $this->processorError("Data insert error: can't be parent to itself!","wiki");
		$db=new Database();
		$db->query("tree","","id=".$id);
		if ($db->num_rows()!=0) return $this->processorError("Data with pageid: ".$id." (".$text.") already exist!",$parentid);
		if (!$this->isUserPage($parentid,"loggedUser",true,P_ADD)) return $this->processorError("INS:Access denied parent:".$parentid.", id: ".$id."!",$parentid);
		$data=array();
		if ($new) $id=uniqid(md5(time()));
		$data['id']=$id;
		$data['parent']=$parentid;
		$data['order']=$order;
		$data['text']=$text;
		$data['userdata']=$this->setUserDataFromPost($userdata);
		if ($db->add_row("tree", $db->makeQuery($data))) {
			if ($new) $_SESSION[WIKI_PREFIX."newPageId"]=$id;
			$this->fixTreeOrder($parentid,$order,$id);
			$this->createSitemap();
			$this->addIdToRefresh($parentid);
			return $this->processorResponse("insert","-1",$id,"");
		} else {
			$this->processorError("Data write error: ".$db->db_error,$parentid);
		}
	}

	function deleteInTree($id,$parentid,$order,$text,$userdata) {
		if (strpos($id,"fake_load_xml")!==false) return $this->processorResponse("delete",$id,$id,"");
		if ($id==$parentid) return $this->processorError("Data delete error: can't be parent to itself!","wiki");
		if ($id==-1) $id=$_SESSION[WIKI_PREFIX."newPageId"];
		$db=new Database();
		$db->query("tree","","id=".$id);
		if ($id=="0" || $id=="wiki") return $this->processorError(str_WIKIITEMDELETENOTPOSSIBLE,$parentid);
		if ($this->tree[$id]['children']!="") return $this->processorError(str_DELETENOTPOSSIBLE,"undelete:".$id);
		if ($db->num_rows()==0) return $this->processorError("Data with pageid: ".$id." (".$text.") doesn't exist!",$parentid);
		if (!$this->isUserPage($id,"loggedUser",true,P_DELETE) || ($parentid!="0" && !$this->isUserPage($parentid,"loggedUser",true,P_EDIT))) return $this->processorError("DEL:Access denied parent:".$parentid.", id: ".$id."!",$parentid);
		if ($db->delete("tree", "id=".$id)) {
			$this->fixTreeOrder($parentid);
			if ($id==$_SESSION[WIKI_PREFIX."newPageId"]) unset($_SESSION[WIKI_PREFIX."newPageId"]);
			$this->createSitemap();
			$this->addIdToRefresh($parentid);
			return $this->processorResponse("delete",$id,$id,$parentid);
		} else {
			$this->processorError("Data write error: ".$db->db_error,"");
		}
	}
/*
	function fixTreeOrder($parentid,$order=-1,$id=-1) {
		$db=new Database();
		$db->query("tree","","parent=".$parentid,"order/ASCN");
		// set order
		$ids=array();
		$o=0;
		$fix=0;
		while ($row=$db->fetch_row()) {
			if ($o==$order && $row['id']==$id) {
				$fix=1;
			}
			if ($id!=-1 || $row['id']!=$id) {
				$new=$o+$fix;
				if ($row['order']!=$new) $ids[$row['id']]=$o+$fix;
				$o++;
			}
		}
		foreach ($ids as $id=>$ord) {
			$data=array();
			$data['order']=$ord;
			$db->update("tree", $db->makeQuery($data),"id=".$id);
		}
		$db->query("tree","","id=".$parentid);
		$row=$db->fetch_row();
		$data=array();
		$data['userdata']=$this->setUserData("levels",$this->nodeLevels($parentid),$row['userdata']);
		$db->update("tree", $db->makeQuery($data),"id=".$parentid);
	}
*/
	function fixTreeOrder($parentid,$order=-1,$id=-1) {
		$db=new Database();
		$db->query("tree","","parent=".$parentid,"order/ASCN");
		// set order
		$ids=array();
		$o=0;
		$fix=0;
		while ($row=$db->fetch_row()) {
			if ($id==-1 || $row['id']!=$id) {
				if ($row['id']!=$id && $o==$order) $o++;
				$ids[$row['id']]=$o;
				$o++;
			}
		}
		foreach ($ids as $id=>$ord) {
			$data=array();
			$data['order']=$ord;
			$db->update("tree", $db->makeQuery($data),"id=".$id);
		}
		$db->query("tree","","id=".$parentid);
		$row=$db->fetch_row();
		$data=array();
		$data['userdata']=$this->setUserData("levels",$this->nodeLevels($parentid),$row['userdata']);
		$db->update("tree", $db->makeQuery($data),"id=".$parentid);
	}

	// server - client pinging
	function userSession($sessionid=false,$command="none",$logged=true) {
		$ret=array();
		$ret['seval']="";
		$ret['message']="";
		$ret['error']="";
		$ret['refreshids']="";
		$ret['expires']=(ini_get("session.gc_maxlifetime")+0)-(time()-$_SESSION[WIKI_PREFIX."sessionStarted"]);
		$ret['whoisonline']=array();
		if ($sessionid===false) $sessionid=session_id();
		if ($sessionid=="") {
			$ret['error']="session not valid";
			return $ret;
		}
		//commands from client
		$com=explode(":",$command);
		switch ($com[0]) {
			case "none":
			break;
			case "":
			break;
		}
		$db=new Database();
		$db->query("sessions");
		$all=array();
		while ($row=$db->fetch_row()) {
			$all[]=$row;
		}
		$db->query("sessions","","sessionid=".$sessionid);
		$data=array();
		$data['timestamp']=time();
		$data['userid']=$this->loggedUserId();
		if ($db->num_rows()==0) {
			$data['sessionid']=$sessionid;
			$db->add_row("sessions", $db->makeQuery($data));
		} else {
			$tmp=$db->fetch_row();
			$data['refreshids']=$tmp['refreshids'];
			$ret['refreshids']=$tmp['refreshids'];
			$db->update("sessions", $db->makeQuery($data),"sessionid=".$sessionid);
		}
		$db->query("sessions","","","timestamp/ASCN");
		$todelete=array();
		$deb=array();
		$tmp=array();
		while ($row=$db->fetch_row()) {
			$deb[]=$row;
			if (($row['timestamp']+0)<(time()-((CLIENT_KICK_OUT+0)*60))) {
				$todelete[]=$row['id'];
			} else {
				if (!isset($tmp[$row['userid']])) $tmp[$row['userid']]=0;
				$tmp[$row['userid']]++;
			}
		}
		foreach ($todelete as $id) {
			$db->delete("sessions","id=".$id);
		}
		foreach ($tmp as $userid=>$num) {
			$ret['whoisonline'][]=$this->user($userid).(($num>1)?(" (".$num.")"):"");
		}
		$ret['whoisonline']=implode(", ",$ret['whoisonline']);
		return $ret;
	}
	
	function idRefreshed($id) {
		$db=new Database();
		$db->query("sessions","","sessionid=".session_id());
		if ($db->num_rows()>0) {
			$data=array();
			$row=$db->fetch_row();
			$data['refreshids']=$this->refreshedids($row['refreshids'],$id);
			$db->update("sessions", $db->makeQuery($data),"id=".$row['id']);
		}
	}
	
	function addIdToRefresh($id) {
		$db=new Database();
		$db->query("sessions","","sessionid!=".session_id());
		if ($db->num_rows()>0) {
			while ($row=$db->fetch_row()) {
				$data=array();
				$data['refreshids']=$this->refreshedids($row['refreshids'],"",$id);
				$db->update("sessions", $db->makeQuery($data),"id=".$row['id']);
			}
		}
	}
	
	function refreshedIds($ids,$remove="",$add="") {
		$ids=explode(",",$ids);
		$remove=explode(",",$remove);
		$add=explode(",",$add);
		$count=count($ids);
		for ($i=0; $i<count($ids); $i++) {
			if (isset($ids[$i]) && in_array($ids[$i],$remove)) unset($ids[$i]);
		}
		foreach ($add as $id) {
			$ids[]=$id;
		}
		return implode(",",array_unique($ids));
	}
	
	function deleteUserSession() {
		$db=new Database();
		$db->delete("sessions","sessionid=".session_id());
		//session_destroy();
	}
}

?>