<?php

// =========================================================
//

// This Software is copyright (c) 2007 by telepark, 
// Inh. Patrick Thomas, www.telepark.de. 
// All rights reserved. 

// You may not modify, alter, reverse engineer or emulate 
// the functionality, or create derivative works of the 
// Software in parts or it's entirety without the prior
// written consent of telepark.
// =========================================================

class WikiPro {
	
	var $newsletter_filename;
	var $userfiles_newsletter;
	var $emaillog_filename;
	var $display_signbox;
  	var $display_searchbox;
  	var $display_logo;
 
	/**
	 * Constructor (PHP5)
	 *
	 */
	function __construct() {
		$this->userfiles_newsletter = "UserFiles/Newsletter/";
		$this->newsletter_filename = "newsletter.txt.php";
		$this->emaillog_filename = "lastemail.log";
		
		$this->display_signbox = SIGNBOX;
		$this->display_searchbox = SEARCHBOX;
		$this->display_logo = LOGO;
		
		if (isset($_GET['unsubscribe'])) {
			$this->system_message = $this->unsubscribeEmail();
		}
	}
	
	/**
	 * Constructor (PHP4)
	 *
	 * @return WikiPro
	 */
	function WikiPro() {
		if ((int) phpversion()<5) $this->__construct();
	}

	/**
	 * Search Box
	 *
	 */
	function searchBox() {
		echo "<div id=\"searchBox\">";
		echo "<form style=\"margin:0;padding:0;\" method=\"get\" action=\"ajax/submitSearch.php\" target=\"actionFrame\" onSubmit=\"return checkSearchField();\">";
		echo "<input type=\"text\" name=\"search\" id=\"search\" value=\"".SEARCH_DEFAULT."\" /> <input type=\"submit\" style=\"width:100px;\" name=\"searchSite\" value=\"" . str_SEARCH . "\" class=\"wikiButton searchButton\" />";
		echo "</form>\n";
		echo "</div>\n";
	}
	
	/**
	 * Notification email sign box
	 *
	 */
	function signBox() {
		echo "<div id=\"signBox\">";
		echo str_SIGNMESSAGE . " ";
		//echo "<form name=\"sign\" method=\"get\" action=\"\" onSubmit=\"submitSignEmail(); return false;\" style=\"margin:0;padding:0;\">";
		echo "<input type=\"text\" id=\"signEmail\" value=\"".SIGN_DEFAULT."\" />&nbsp;<input type=\"submit\" class=\"wikiButton signButton\" style=\"width:100px\" name=\"submitSign\" value=\"" . str_SIGNONOFF . "\" onClick=\"submitSignEmail();\" />";
		//echo "</form>";
		echo "</div>\n";
	}

	/**
	 * Sign email
	 *
	 * @param string $email
	 */
	function signEmail($email) {
		$filename = PRE . $this->userfiles_newsletter . $this->newsletter_filename;
		$email = stripslashes($email);
		$email_exists = false;
		$string = $str_action = $error = "";
		
		// incorrect email address
		if (!preg_match("/[A-Za-z0-9_-]+([\.]{1}[A-Za-z0-9_-]+)*@[A-Za-z0-9-]+([\.]{1}[A-Za-z0-9-]+)+/",$email) || (eregi("bcc:",$email) || eregi("cc:",$email) || eregi("from:",$email) || eregi("subject:",$email))) {
			return array("",str_EMAILERROR);
		}
		
		// file existing?
		if (!file_exists($filename)) {
			$fp = @fopen($filename,"w");
			if (!$fp) {
				echo "<script>parent.displaySystemMessage(\"" . htmlentities(err_NEWSLETTERNOTFOUND,ENT_QUOTES,"utf-8") . "\");</script>";
				echo "<script>parent.logError(\"" . addslashes(err_NEWSLETTERNOTFOUND) . "\");</script>";
			} else {
				fclose($fp);
			}
		}
		// read file
		$content = file($filename);
		// search email address
		foreach ($content as $row) {
			if (trim(strtolower($email)) == trim(strtolower($row))) {
				$email_exists = true;
			}
		}
		// add email address
		if ($email_exists === false) {
			$content[] = trim(strtolower($email));
			$str_action = str_EMAILADDED;
			$action = "add";
		}
		// remove email address
		elseif ($email_exists === true) {
			for ($i=0; $i<count($content); $i++) {
				if (trim(strtolower($content[$i])) == trim(strtolower($email))) {
					$content[$i] = "";
					$str_action = str_EMAILREMOVED;
					$action = "remove";
				}
			}
		}
		// generate list
		foreach ($content as $row) {
			if (trim($row) != "" && trim($row) != " " && trim($row) != "<?php" && trim($row) != "?>" && trim($row) != "/*" && trim($row) != "*/") {
				$string .= $row;
			}
		}
		$string = "<?php\n/*\n" . $string . "\n*/\n?>";
		// write email list
		$fp = @fopen($filename,"w");
		flock($fp,2);
		fputs($fp,$string);
		flock($fp,3);
		fclose($fp);
		// error
		if ($str_action == "") {
			$error = str_EMAILERROR;
		} elseif ($this->sendConfirmationEmail($email,$action) == false) {
			$str_action .= " " . str_EMAILCONFIRMATION_ERROR;
		}
		// return messages
		return array($str_action,$error);
	}
	
	/**
	 * Unsubscribe newsletter via link
	 *
	 * @return string
	 */
	function unsubscribeEmail() {
		$filename = PRE . $this->userfiles_newsletter . $this->newsletter_filename;
		$email = stripslashes($_GET['unsubscribe']);
		$email_exists = false;
		$string = $message = "";
		
		// incorrect email address
		if (!preg_match("/[A-Za-z0-9_-]+([\.]{1}[A-Za-z0-9_-]+)*@[A-Za-z0-9-]+([\.]{1}[A-Za-z0-9-]+)+/",$email) || (eregi("bcc:",$email) || eregi("cc:",$email) || eregi("from:",$email) || eregi("subject:",$email))) {
			return str_UNSUBSCRIBE_INVALID_EMAIL;
		}
		// file existing?
		if (!file_exists($filename)) {
			$fp = fopen($filename,"w");
			if (!$fp) {
				$message = err_NEWSLETTERNOTFOUND;
			} else {
				fclose($fp);
			}
		}
		// read file
		$content = file($filename);
		// search email address
		foreach ($content as $row) {
			if (trim(strtolower($email)) == trim(strtolower($row))) {
				$email_exists = true;
			}
		}
		// remove email address
		if ($email_exists === true) {
			for ($i=0; $i<count($content); $i++) {
				if (trim(strtolower($content[$i])) == trim(strtolower($email))) {
					$content[$i] = "";
					$message = str_EMAILREMOVED;
				}
			}
		} else {
			$message = ($message==""?str_EMAILNOTFOUND:$message);
		}
		// generate list
		foreach ($content as $row) {
			if (trim($row) != "" && trim($row) != " " && trim($row) != "<?php" && trim($row) != "?>" && trim($row) != "/*" && trim($row) != "*/") {
				$string .= $row;
			}
		}
		$string = "<?php\n/*\n" . $string . "\n*/\n?>";
		// write email list
		$fp = @fopen($filename,"w");
		flock($fp,2);
		fputs($fp,$string);
		flock($fp,3);
		fclose($fp);
		// error
		if ($message == "") {
			$message = str_EMAILERROR;
		} elseif ($message != str_EMAILNOTFOUND) {
			if ($this->sendConfirmationEmail($email,'remove') == false) {
				$message .= " " . str_EMAILNOTIFICATION_ERROR;
			}
		}
		// return messages
		return $message;
	}
	
	/**
	 * Send confirmation email
	 *
	 * @param string $email
	 * @param string $action
	 * @return boolean
	 */
	function sendConfirmationEmail($email,$action) {
		switch ($action) {
			case "add": $bodycontent = str_EMAILNOTIFICATION_ADD; break;
			case "remove": $bodycontent = str_EMAILNOTIFICATION_REMOVE; break;
		}
		
		// email header
		$header  = "From: " . ADMINMAIL ."\r\n";
		$header .= "Reply-To: " . ADMINMAIL . "\r\n";
		$header .= "Content-type: text/html; charset=utf-8\r\n";
		// email body
		$body = "<html><head><style>body { font-family:Verdana,Arial,Helvetica,sans-serif; font-size:10px; }</style></head><body>";
		$body .= $bodycontent;
		$body .= "<br />";
		$body .= str_EMAILFOOTER2;
    	$body .= "</body></html>";
    	// build unsubscribe link
    	$unsubscribelink = "<a href=\"" . ROOT_URL . "/index.php?unsubscribe=" . $email . "\">" . ROOT_URL . "/index.php?unsubscribe=" . $email . "</a>";
    	// build mailbody
    	$mailbody = str_replace("[UNSUBSCRIBELINK]",$unsubscribelink,$body);
		// send mail
    	$mail = @mail($email,str_EMAILSUBJECT_CONFIRMATION,$mailbody,$header);
		// log errors
		if (!$mail) {
			$this->logAppError('Notification mail (\'' . $action . '\') could not be send.',$_SERVER['SCRIPT_FILENAME'],__LINE__);
			return false;
		} else {
			return true;
		}
		
	}
	
	/**
	 * Send email
	 *
	 */
	function sendEmail() {
		// check if email notification enabled
		if (EMAILNOTIFICATION == false) return array("","");
		$changes = $this->readChanges();
		//get tree
		
		$filename = PRE . $this->userfiles_newsletter . $this->newsletter_filename;
		$error = false;
		$error_msg = $success_msg = "";
		$numofemails=0;
		
		// create newsletter file if it doesn't exist
		if (!file_exists($filename)) {
			$fp = @fopen($filename, "w");
			fclose($fp);
		}
		
		if (file_exists($filename) && ($this->getChangeEmailDate()<(time()-3600) || EMAIL_NOW=="true")) {
			$list = file($filename);
			
			// get tree titles
			$title = $this->getTreeTitles();
			
			//first send group pages changes to group members
			
			// email header
			
			$header  = "From: " . ADMINMAIL ."\r\n";
			$header .= "Reply-To: " . ADMINMAIL . "\r\n";
			$header .= "Content-type: text/html; charset=utf-8\r\n";
			$db=new Database();
			$db->query("users");
			while ($row=$db->fetch_row()) {
				$email=$row['email'];
				// email body
				$innerbody="";
				$body = "<html><head><style>body { font-family:Verdana,Arial,Helvetica,sans-serif; font-size:10px; }</style></head><body>";
				$body .= str_EMAILNOTIFICATION;
				$body .= "<br /><br />";
				$nochanges2 = true;
				foreach ($changes as $k => $changelog) {
					if (count($changelog)>0 && array_key_exists($k,$title) && $this->isUserPage($k,$email,false,P_READ)) {
						$body = "<a href=\"" . str_replace("/ajax","",ROOT_URL) . "/" . $this->getSEOUrl($k) . "\"><strong>" . $title[$k] . "</strong></a>:<br />";
						foreach ($changelog as $c) {
							if (UNDOCUMENTED_CHANGES=="true") {
								$innerbody .= $c . "<br />";
							} else {
								if (strpos($c,str_UNDOCUMENTED)===false) $innerbody .= $c . "<br />"; 
							}
						}
						if ($innerbody!="") {
							$body .= $innerbody."<br />";
							$nochanges2 = false;
						}
					}
				}
				// email footer
			
				$body .= "<br />" . str_EMAILFOOTER;
				//$body .= "<br /><br />" . str_EMAILUNSUBSCRIBE . " <a href=\"" . str_replace("/ajax","",ROOT_URL) . "/index.php?unsubscribe=[EMAILADDRESS]\">" . str_replace("/ajax","",ROOT_URL) . "/index.php?unsubscribe=[EMAILADDRESS]</a>";
			
				$body .= str_EMAILFOOTER2;
				$body .= "</body></html>";
				// send email
				if (!$nochanges2) {
					$mailbody = str_replace("[EMAILADDRESS]",$email,$body);
					$mail = @mail($email,str_EMAILSUBJECT,$mailbody,$header);
					if (!$mail) {
						$error = true;
					} else {
						$numofemails++;
					}
				}
			}
			//then send public page changes to newsletter signup
			// email header
			$header  = "From: " . ADMINMAIL ."\r\n";
    		$header .= "Reply-To: " . ADMINMAIL . "\r\n";
    		$header .= "Content-type: text/html; charset=utf-8\r\n";
    		// email body
    		$innerbody="";
    		$body = "<html><head><style>body { font-family:Verdana,Arial,Helvetica,sans-serif; font-size:10px; }</style></head><body>";
			$body .= str_EMAILNOTIFICATION;
			$body .= "<br /><br />";
			$nochanges = true;
			// generate list
			foreach ($changes as $k => $changelog) {
				if (count($changelog)>0 && array_key_exists($k,$title) && $this->isPublic($k)) {
					$body .= "<a href=\"" . str_replace("/ajax","",ROOT_URL) . "/index.php?page=" . $k . "\"><strong>" . $title[$k] . "</strong></a>:<br />";
					foreach ($changelog as $c) {
						if (UNDOCUMENTED_CHANGES=="true") {
							$innerbody .= $c . "<br />";
						} else {
							if (strpos($c,str_UNDOCUMENTED)===false) $innerbody .= $c . "<br />"; 
						}
					}
					if ($innerbody!="") {
						$body .= $innerbody."<br />";
						$nochanges = false;
					}
				}
			}
			// email footer
			$body .= "<br />" . str_EMAILFOOTER;
			$body .= "<br /><br />" . str_EMAILUNSUBSCRIBE . " <a href=\"" . str_replace("/ajax","",ROOT_URL) . "/index.php?unsubscribe=[EMAILADDRESS]\">" . str_replace("/ajax","",ROOT_URL) . "/index.php?unsubscribe=[EMAILADDRESS]</a>";
    		$body .= str_EMAILFOOTER2;
    		$body .= "</body></html>";
    		// send emails
			if ($nochanges == false) {
	    		foreach ($list as $emailaddress) {
					if (trim($emailaddress) != "" && trim($emailaddress) != " " && trim($emailaddress) != "<?php" && trim($emailaddress) != "?>" && trim($emailaddress) != "/*" && trim($emailaddress) != "*/") {
						$mailbody = str_replace("[EMAILADDRESS]",$emailaddress,$body);
						$mail = @mail($emailaddress,str_EMAILSUBJECT,$mailbody,$header);
//						$mail = @mail("tuckdesign@yahoo.com",str_EMAILSUBJECT.str_replace(".","_",str_replace("@","_",$emailaddress)).date("d_m_Y_H_i"),$mailbody,$header);
						if (!$mail) {
							$error = true;
						} else {
							$numofemails++;
						}
					}
				}
			
				// error
				if ($error == true) {
					//echo $body;
					// log email timestamp	
					if ($numofemails>0) $this->logChangeEmailDate();
					$error_msg = "An error occurred. At least one email could not be sent.";
				}
			}
			// no changes
			else {
				$success_msg = "Newsletter not sent. No changes since last newsletter.";
			}
			if ($error_msg == "") {
				// log email timestamp	
				$this->logChangeEmailDate();
				$success_msg = "No errors. All emails send!";
			}
		}
		// file not found
		elseif (!file_exists($filename)) {
			$error_msg = "Newsletter not sent. Newsletter list is empty and the file doesn't exist.";
		}
		// too early
		else {
			$success_msg = "No newsletter send. Last one sent within the last 24 hours.";
		}

		return array($success_msg,$error_msg);
	}
	
	/**
	 * Log date of last change email
	 *
	 */
	function logChangeEmailDate() {
		$content = time();
		$fp = @fopen(PRE . $this->userfiles_changes . $this->emaillog_filename, "w");
		if ($fp) {
			flock($fp,2);
			fputs($fp,$content);
			flock($fp,3);
			fclose($fp);
		}
	}
	
	/**
	 * Get date of last change email
	 *
	 */
	function getChangeEmailDate() {
		$filename = PRE . $this->userfiles_changes . $this->emaillog_filename;
		$date = "";
		if (file_exists($filename)) {
			$file = file($filename);
			$date = trim($file[0]);
		}
		if ($date == "" || !isset($date)) $date = mktime(12,0,0,1,1,1970);
		return $date;
	}
	
	/**
	 * Read wiki changes from change logs
	 *
	 */
	function readChanges() {
		$dir = opendir(PRE . $this->userfiles_changes);
		$changelist = array();
		while($file = readdir($dir)){
		  if ($file != "." && $file != ".." && $file != $this->emaillog_filename && $file != $this->changelog_filename && strtolower(substr($file,strlen($file)-4)) == ".log") {
			$changelist[str_replace(".log","",$file)] = $this->readChangesFromFile(PRE . $this->userfiles_changes . $file);
		  }
		}
		closedir($dir);
		return $changelist;
	}
	
	/**
	 * Read wiki changes from change files
	 *
	 * @param string $file
	 */
	function readChangesFromFile($file) {
		$string = array();
		
		//$date = date("Y-m-d H:i:s",$this->getChangeEmailDate());
		$date = $this->getChangeEmailDate();
		//echo "date: " . date("Y-m-d H:i:s",$date) . "<br>";
		if (file_exists($file)) {
			$file_array = file($file);
			// search first change log from specified date
			for ($i=0; $i<count($file_array); $i++) {
				$start = $i;
				if (eregi("[[:digit:]]{4}(-)[[:digit:]]{2}(-)[[:digit:]]{2}( )[[:digit:]]{2}(:)[[:digit:]]{2}(:)[[:digit:]]{2}",substr($file_array[$i],0,19)) && ($this->makeTimestamp(substr($file_array[$i],0,19)) > $date)) {
					//echo "log: " . substr($file_array[$i],0,19) . "<br>";
					break;
				}
			}
			// read changes since specified date
			for ($i=$start; $i<count($file_array); $i++) {
				if (trim($file_array[$i]) != "") {
					$string[] = trim($file_array[$i]);
				}
			}
		}
		return $string;
	}
	
	/**
	 * Make timestamp from date string
	 *
	 * @param string $str
	 * @return int
	 */
	function makeTimestamp($str) {
		$str = trim($str);
		$split = explode(" ",$str);
		$date = explode("-",$split[0]);
		$time = explode(":",$split[1]);
		return mktime($time[0],$time[1],$time[2],$date[1],$date[2],$date[0]);
	}
	
	/**
	 * Update Superadmin state in file
	 *
	 * @param int $pageID
	 */
	function updateSuperadminState($pageID,$state=0) {
		if ($pageID != "") {
			$filename = $pageID . ".wiki";
			$path = PRE . $this->userfiles_pages . $filename;
			$data = array();
			$s = $found = "";
			$safound = $samodified = false;
			// read content
			if (file_exists($path)) {
				$file = file($path);
				for ($i = 0; $i<count($file); $i++){
				  	if (preg_match("/<!-- SA Start -->(.*?)<!-- SA End -->/",$file[$i],$regs)) {
						if ($regs[1] != (int) $state) {
					  		$s .= "<!-- SA Start -->" . (int) $state . "<!-- SA End -->\n";
					  		$samodified = true;
					  		$found = $regs[1];
						}
						else {
							$s .= $file[$i];
						}
						$safound = true;
					} else {
						$s .= $file[$i];
					}
				}
				if ($safound === false) {
					$s .= "<!-- SA Start -->" . (int) $state . "<!-- SA End -->\n";
				}
			}
			// write content
			if ($samodified === true) {
				$fp = fopen($path, "w");
				flock($fp,2);
				fputs($fp,$s);
				flock($fp,3);
				fclose($fp);
				// save changes timestamp
				$this->saveChangestamp();
			}
		}
		return array($samodified,"");
	}
	
	/**
	 * Extract titles from tree xml file
	 *
	 * @return array
	 */
	function getTreeTitles() {
		$data=array();
		foreach ($this->tree as $id => $item) {
			$data[$id]=$item['text'];
		}
		return $data;
	}
	
	/**
	 * Search phrase
	 *
	 * @param string $string
	 */
	function searchPhrase($string) {
		//$string = stripslashes($string);
		$string = htmlentities(stripslashes($string),ENT_QUOTES,"utf-8");
		
		// read contents
		$dir = opendir(PRE . $this->userfiles_pages);
		$pagelist = array();
		while($file = readdir($dir)){
		  if ($file != "." && $file != ".." && strtolower(substr($file,strlen($file)-5)) == ".wiki" && $this->isUserPage(str_replace(".wiki","",$file),"loggedUser",true,P_READ)) {
			$content = $this->loadPage(str_replace(".wiki","",$file));
		  	if ($content['wikiSuperadminPage'] == 1 && ((isset($_SESSION[WIKI_PREFIX.'wsuperadmin']) && $_SESSION[WIKI_PREFIX.'wsuperadmin'] != 1) || !isset($_SESSION[WIKI_PREFIX.'wsuperadmin']))) {
		  		$access = false;
		  	}
		  	else {
		  		$access = true;
		  	}
			if ($this->searchPage($content,$string) != false && $access == true) {
		  		$pagelist[str_replace(".wiki","",$file)] = $content;
		  	}
		  }
		}
		closedir($dir);
		
		//print_r($pagelist);
		
		return $pagelist;
	}
	
	/**
	 * Search page for search phrase
	 *
	 * @param array $content
	 * @param string $searchstring
	 * @return boolan
	 */
	function searchPage($content,$searchstring) {
		$s = explode(" ",$searchstring);
		$found = true;
		for ($i=0; $i<count($s); $i++) {
			if (!eregi($s[$i],$content['wikiMenuLabel']) && !eregi($s[$i],strip_tags($content['wikiContent']))) {
				$found = false;
			}
		}
		return $found;
	}
	
	/**
	 * Get search context
	 *
	 * @param array $content
	 * @param string $searchstring
	 * @return string
	 */
	function getSearchContext($content,$searchstring) {
		$content = stripslashes(strip_tags($content));
		$s = explode(" ",stripslashes($searchstring));
		$teaserstring = "... ";
		// loop search strings
		for ($i=0; $i<count($s); $i++) {
			//$s[$i] = htmlentities($s[$i],ENT_QUOTES,"utf-8");
			// split words
			$string = explode(" ",$content);
			$position = array();
			// loop words and compare with search string
			foreach ($string as $pos => $word) {
				if (strpos(strtolower(preg_replace("/&[\w]*;/","",str_replace("&amp;","&",htmlentities($word)))),strtolower(preg_replace("/&(\w)*;/","",str_replace("&amp;","&",htmlentities($s[$i])))))!==false) {
					$position[] = $pos;
				}
			}
			// loop search results
			foreach ($position as $pos) {
				// start word
				if ($pos-2>=0) {
					$start = $pos-2;
				}
				elseif ($pos-1>=0){
					$start = $pos-1;
				}
				else {
					$start = 0;
				}
				// end word
				if ($pos+2<count($string)) {
					$end = $pos+2;
				}
				elseif ($pos+1<count($string)) {
					$end = $pos+1;
				}
				else {
					$end = $pos;
				}
				// build result string
				for ($z=$start; $z<=$end; $z++) {
					$teaserstring .= ($pos == $z?"<strong>":"") . $string[$z] . ($pos == $z?"</strong>":"") . " ";
				}
				$teaserstring .= " ... ";
			}
		}
		return (strlen($teaserstring)>256)?substr($teaserstring,0,256) . "...":$teaserstring;
	}

	/**
	 * Lock file
	 *
	 * @param string $pageID
	 */
	function  lockFile($pageID) {
		$filename = PRE . $this->userfiles_pages . $pageID . ".lock";
		if (!file_exists($filename)) {
			$fp = @fopen($filename, "w");
			if (!$fp) {
				//echo "<script>parent.displaySystemMessage(\"" . htmlentities(err_LOCKNOTWRITEABLE,ENT_QUOTES,"utf-8") . "\");</script>";
				echo "<script>parent.logError(\"" . addslashes(err_LOCKNOTWRITEABLE) . "\");</script>";
			} else {
				flock($fp,2);
				fputs($fp,time() . ":" . session_id());
				flock($fp,3);
				fclose($fp);
			}
		}
	}
	
	/**
	 * Unlock file
	 *
	 * @param string $pageID
	 */
	function unlockFile($pageID) {
		$filename = PRE . $this->userfiles_pages . $pageID . ".lock";
		if (file_exists($filename)) {
			$ul = @unlink($filename);
		}
		if (isset($ul) && $ul == true) {
			return array("Lock file deleted: " . $pageID . ".lock","");
		} else {
			return array("","Lock file could not be deleted: " . $pageID . ".lock");
		}
		
	}
	
	/**
	 * Check all pageIDs for lock
	 *
	 * @return array
	 */
	function checkLockFiles() {
		$sid = session_id();
		$dir = opendir(PRE . $this->userfiles_pages);
		$n = 0;
		while($file = readdir($dir)){
			if (strtolower(substr($file,strlen($file)-5)) == ".lock") {
				$filecontent = file_get_contents(PRE . $this->userfiles_pages . $file);
				$content = explode(":",$filecontent);
				// file content format correct
				if (count($content==2)) {
					$time = $content[0];
					$fsid = $content[1];
					if (trim($fsid) == $sid || $time<(time()-LOCKTIMEOUT)) {
						@unlink(PRE . $this->userfiles_pages . $file);
						$n++;
					}
				} else {
					@unlink(PRE . $this->userfiles_pages . $file);
					$n++;
				}
		  	}
		}
		return array($n . " files unlocked","");
	}
	
	/**
	 * Check if pageID is locked
	 *
	 * @param string $pageID
	 * @return boolean
	 */
	function fileLocked($pageID) {
		$filename = PRE . $this->userfiles_pages . $pageID . ".lock";
		// file exists?
		if (file_exists($filename)) {
			$filecontent = file_get_contents($filename);
			$content = explode(":",$filecontent);
			// file content format correct
			if (count($content==2)) {
				$time = $content[0];
				$sid = $content[1];
				// lock file expired
				if ($time<(time()-LOCKTIMEOUT) || $sid == session_id()) {
					$this->unlockFile($pageID);
					return false;
				}
				// lock file valid
				else {
					return true;
				}
			}
			return false;
		}
		// file doesn't exist
		else {
			return false;
		}
	}
	
}