<?php

// =========================================================
//

// This Software is copyright (c) 2007 by telepark, 
// Inh. Patrick Thomas, www.telepark.de. 
// All rights reserved. 

// You may not modify, alter, reverse engineer or emulate 
// the functionality, or create derivative works of the 
// Software in parts or it's entirety without the prior
// written consent of telepark.
// =========================================================

// include app header
	if (file_exists("setup.php")) {
		if (isset($_POST['setup_step'])) {
			header("Location: setup.php?finish=".$_POST['setup_step']);
		} else {
			header("Location: setup.php");
		}
		exit();
	}

if (file_exists("includes/app_header.inc.php")) {
	include_once("includes/app_header.inc.php");
} else {
	include_once("install/includes/app_header.inc.php");
}

ob_start("ob_gzhandler");

if (KEYCODE=="") die("No keycode present!");

// init database system
$db=new Database();
$db->create("users","userid,username,email,password,groupids,lastlogin,messenger,photo,friends,gmuntill,birthday,homepage,url");
$db->create("groups","groupid,groupname,defperms,tags");
$db->create("pages","id,pageid,privileges");
$db->create("urls","id,pageid,url");
$db->create("keywords","id,pageid,key");
$db->create("descriptions","id,pageid,desc");
$db->create("titles","id,pageid,title");
$db->create("sessions","id,sessionid,userid,timestamp,refreshids,data");

// create group Guest if doesn't exist
$db->query("groups","","groupname=Guest");
if ($db->num_rows()==0) $db->add_row("groups","groupname=Guest");

// assign group Guest to wiki page if not already and use old privileges system for it
$db->query("pages","privileges","pageid=wiki");
if ($db->num_rows()==0) {
	$oldprivs=P_READ;
	if (CONFIG_ADD_COMMENTS=="YES") $oldprivs=$oldprivs|P_COMMENT;
	if (PUBLIC_LOGIN=="true") $oldprivs=$oldprivs|P_EDIT|P_ADD|P_DELETE|P_DRAGNDROP|P_LOGEDIT;
	$db->add_row("pages","privileges=0|".$oldprivs.",pageid=0");
	$db->add_row("pages","privileges=0|".$oldprivs.",pageid=wiki");
}

define("INDEX_URL",str_replace("index.php","",$_SERVER['PHP_SELF']));

// init wiki class
$wiki = new Wiki();

// does page exist?
if (isset($_GET['page']) AND !in_array($_GET['page'],explode(",",SPECIAL_PAGES))) {
	$tmpID=$wiki->getPageIDFromUrl($_GET['page']);
	if ($tmpID===false OR !$wiki->isUserPage($tmpID,"loggedUser",true)) {
		header("HTTP/1.0 404 Not Found");
		define("CALLED_PAGEID","");
	} else {
		define("CALLED_PAGEID",$tmpID);
	}
} else {
		define("CALLED_PAGEID","");
}

if (IS_MOBILE) {
	$_SESSION[WIKI_PREFIX.'gets']=$_GET;
	$_SESSION[WIKI_PREFIX.'posts']=$_POST;	
	$mobile=new WikiMobile($wiki);
	$mobile->htmlheader();
	if (isset($_GET['page']) AND $_GET['page']=="login" AND $wiki->checkLogin()===false AND !$mobile->loggingInFailed) {
		$mobile->logo();
		$mobile->loginForm();
	} else {
		$mobile->logo();
		$mobile->menuHoriz();
		
		//$mobile->searchBox();
		$mobile->printPage();
		$mobile->printTree();
	}
		$mobile->htmlfooter();
} else {

	// html header
	$wiki->htmlheader();
	
	// actions box
	$wiki->actionsbox();
	
	// header
	$wiki->topbanner();
	
	// version number
	$wiki->versionNumber();
	
	// login button
	$wiki->loginButton();
	
	// tree
	$wiki->treebox();
	
	//start of content
	$wiki->main_start();
	
	// loading animation
	$wiki->status();
	
	// login
	$wiki->loginBox();
	
	// message box
	$wiki->messagebox();
	
	// content
	$wiki->content();
	
	//start of content
	$wiki->main_end();
	
	// helper frame
	$wiki->actionFrame();

	// SEO hidden page
	$wiki->SEO();
	
	// html footer
	$wiki->htmlfooter();
}
?>